# 
#     26 Oct 96   for da adopted from charissa version
#    8 jan 98   modified for use with F2VB module


set VERSION "1394"

set env(RDOUThdwre) 1394
set env(RDOUTserver) DAQ
set env(SHistServer) MemSas
set DAProgram 1394execV1.exe

loadsource  sys.common

set frametitle "MIDAS Data Acquisition System Control (VXI/1394)"

set CAMACPresent 0
set VMEPresent 0
set VXIPresent 1

set CAMACEnable 0
set VMEEnable 0
set VXIEnable 1

set RDOUTEnable 1

set histEnable 1
set HistMode 0

set txEnable 0

set MaxTries 10

lappend setuplist [list "Force Spectrum Map needed"          map_needed]

lappend actionlist [list "Raw Data Display"  "Dump_Raw_VXI_Data"]

lappend registerlist [list EXEC.Response  generic  "-nEXEC_Response -tblock -ayes -i200 -l444 -fx"]


proc Set_Options {} {
    global Options

    load_Options

    Set_Common_Options

    update_Options
}

proc Dump_Raw_VXI_Data {} {

      set data "VXI\n"

      execute-command 19 "Getting Raw Data for VXI" "4 1" 2
      append data [read-register EXEC.Response]
      append data "\n"

   midas-information "$data"
}

proc Setup_Rdout {} {

    ClearConfig
    DefineConfig ""
    PrintConfig
}

proc setup_histograms {} {
     global SpectrumServer Options

#    create and enable histograms

     set-footer "Setting up histogramming"

     set range $Options(Stat.channels)
     set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Stat' !new)" } m]
     map_spectrum Stat

     set range $Options(Rate.channels)
     set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $range :name 'Rate' !new)" } m]

#     all other spectra created by the VXI software histogram interface

     clear-footer
}

proc map_spectra {} {
   global EGreport RDOUThdwre

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   if {[read-register $RDOUThdwre.Cspectramapped] == 1} {return}

   set-busy
   set-footer "Mapping spectra"

   set EGreport_SAVE $EGreport
   set EGreport -1

   set l [spectra-names]
   set num 0
   foreach item $l {
       incr num
       set name [second $item]
       if {"$name" == "Stat"} continue
       if {"$name" == "Rate"} continue
       map_spectrum $name
       if {[expr ($num/10)*10] == $num} {set-footer "mapped spectrum $name"}
#       set-footer "mapped spectrum $name"
   }

   write-register $RDOUThdwre.Cspectramapped 1

   set EGreport $EGreport_SAVE

   set-footer "mapped [llength $l] spectra"
   clear-busy
}

proc map_spectrum {s} {

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

   execute-command 10 "Mapping spectrum $s" "$s"
}

proc map_needed {} {global RDOUThdwre; write-register $RDOUThdwre.Cspectramapped 0}

