/*--> ======================================================= <--*/
/*--> sort-calls.h : Include file listing all of the global   <--*/
/*-->                variables that need to be seen by all    <--*/
/*-->                the routines.                            <--*/
/*-->                                                         <--*/
/*-->                This version created by DEA Feb 27/03    <--*/
/*-->                                                         <--*/
/*--> ======================================================= <--*/
#ifndef _MIDASSORTGLOBALS_
#define  _MIDASSORTGLOBALS_
/*--> ======================================================= <--*/
#include "midas_sort_defn.h"
/*--> ======================================================= <--*/
#define LIBPATH      "/MIDASsort/lib/"
/*--> ======================================================= <--*/
#define MAX_DATA_WRDS ( 1024 )
/*--> ======================================================= <--*/
struct SV {
 char specdir  [ 128 ];
 char inputdev [ 128 ];
 char outputdev[ 128 ];
 char inputfmt [ 128 ];
 char tdev     [ 128 ];
 int  overwritespectra;
 short  (*evt_routine)( unsigned short *, unsigned int *, unsigned int *, unsigned int * );
 short  *(*blk_routine)( short **, int **, int * );
 void *evt_module;
 void *blk_module;
};
/*--> ======================================================= <--*/
struct SSINFO {
 char name [ 64 ];
 int  type;
 int  len;
 int  *pCount;
} ssinfo[ 1024 ];
/*--> ======================================================= <--*/
struct SHIST {
 char        name [ 32 ];
 short int   group;
 short int   item;
 short int   label;
 short int   enable;
 short int   databits;
 int        *pCount;
} Myhist[ NUMHIST ];
/*--> ======================================================= <--*/
struct MYSHARE {
 int             action           ;
 int             debuglevel       ;
 int             toggle_hist      ;
 int             garray           ;
 int             mypos            ;
 int             trace            ;
 int             tracelevel       ;
 int             bad_jrc          ;
 int             useri       [ 4 ];
 unsigned int    userui      [ 4 ];
 short           users       [ 4 ];
 unsigned short  datablk [ 65536 ];
 float           gainarray        ;
 float           usersf      [ 4 ];
} *myshare;
struct DINFO {
  short start_pos[ MAX_DATA_WRDS ];
  short wrd_count[ MAX_DATA_WRDS ];
};
/*--> ======================================================= <--*/
/*--> Have we got a signal ..?                                <--*/
extern volatile int gotsig;
extern int *debug_level;
extern int debug_status;
extern int *trace_toggled;
extern int *trace_level;
extern int *bad_jrc;
int ui;
/*--> ======================================================= <--*/
/*--> Some MIDAS setup stuff .....                            <--*/
extern char *exptdir;
/*--> ======================================================= <--*/
/*--> Some data storage stuff ...                             <--*/
unsigned int   *gid;
unsigned int   *gdata;
unsigned int   *nwrds;
int             mult;
extern int     *histconv;
extern float   *gainarray;
extern int     *gatelists;
int             gdblk_pos;
int            *guseri;
unsigned int   *guserui;
short          *gusers;
float          *guserf;
/*--> ======================================================= <--*/
/*--> Some shared memory stuff ..                             <--*/
int   shmid1;
/*--> ======================================================= <--*/
/*--> Some MIDAS related stuff ..                             <--*/
char   *exptdir;
/*--> ======================================================= <--*/
#endif
/*--> ========================================================== <--*/
