#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> browse_sortfile.tcl                                     <--#
#-->                                                         <--#
#--> This routine launches the inbuilt directory browser     <--#
#--> and returns the name of the chosen file to the          <--#
#--> main program (sortfilename)                             <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc browse_sortfile args {
    global env sortfilename directory
    global file_status execfilename

    option add *Canvas.background  #c0c020
    set types {
	{ {C Source Files } {*.c} }
	{ {MIDAS Sort Files} {*.sfm} }
	{ {F77 Source Files } {*.f} }
    }

    set file [tk_getOpenFile -parent [self frame-name] \
		  -title "Input SortFile Selection"  \
		  -initialdir $directory -filetypes $types]
    option add *Canvas.background  $env(tkcanvasbackground)
    if {$file == ""} then {return}

    set sortfilename $file
    :modify TSORTFILE :value $sortfilename
#--> To ensure that we can see the last bit of the string <--#
    [:path TSORTFILE].entry xview 200
#--> What is the status of this file ....?                <--#
    set execute "exec filestatus_midas_sort $sortfilename"
    set rc [catch { exec filestatus_midas_sort $sortfilename } m]

    switch $m {
	0     { set file_status "To BE Compiled" }
	1     { set file_status "Compiled"}
	2     { set file_status "Exe file older than src" }
	3     { set file_status "Please recompile" }
    }

    :modify STATE :label $file_status
    :modify BEDITFILE :inactive F
    :modify BCOMPILE :inactive F


#--> Now extract the executable filename
    set rc [catch { exec return_exe $sortfilename } m]
    set execfilename $m

}
