#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Check to see if we have a valid EXPERIMENTDIR set       <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc check_experiment {} {
    #--> before we look for any resources we have to ensure
    #--> that we are connected to a valid experiment
    global env mydebug userexpt

    if { $mydebug == 1 } then { puts "check_experiment: Entered" }
    if { $mydebug == 1 } then { array names env EXPERIMENTBASE }

    if { [ array names env EXPERIMENTBASE ] != "EXPERIMENTBASE" } then {
	set env(EXPERIMENTBASE) ""
    }

    if { $env(EXPERIMENTBASE) == "" } then {
	if { $mydebug == 1 } then { puts "check_experiment: NO Valid Expt" }
	#--> First we have to check are we big or little endian. It should not matter
	#--> for us as we are creating something on the fly, else .....
	if { $env(EXPUSEENDIAN) == "true" } then {
	    set endian $env(ENDIAN)
	} else {
	    set endian "big"
	}
	if { $mydebug == 1 } then { puts "check_experiment: endian     -> $endian " }
	set filename "capabilities"
	if { $mydebug == 1 } then { puts "check_experiment: filename   -> $filename" }
	#--> The name for this experiment is ....
	set experiment "midassort"
	if { $mydebug == 1 } then { puts "check_experiment: experiment -> $experiment" }
	set directory [file join $env(MIDASTempDir) tcl[pid]]
	set z [ catch { :file mkdir [ file join $directory $experiment ] } m ]
	if { $z != 0 } then {
	    splash_update "Setting Experiment FAILED"
	    return
	}
	if { $endian != "big" } then {
	    set z [ catch { :file mkdir [ file join $directory $experiment $endian] } m ]
	    if { $z != 0 } then {
		splash_update "Setting Experiment FAILED"
		return
	    }
	}
	if { $mydebug == 1 } then { puts "check_experiment: Directory created" }
	#--> now set the Experiment directory
	if { $endian == "big" } then {
	    :experiment new :path [ file join $directory $experiment ] :name $filename
	    if { $mydebug == 1 } then { puts "check_experiment: Tempory experiment has been created" }
	    splash_update "Tempory experiment has been created ..."
	} else {
	    :experiment new :path [ file join $directory $experiment ] :name $filename
	    if { $mydebug == 1 } then { puts "check_experiment: Tempory experiment has been created" }
	    splash_update "Tempory experiment has been created ..."
	}

	if { $endian == "big" } then {
	    :experiment connect :path [ file join $directory $experiment ] :name $filename
	    set env(EXPERIMENTDIR) [ file join $directory $experiment ]
	    if { $mydebug == 1 } then { puts "check_experiment: Tempory experiment has been joined" }
	} else {
	    :experiment connect :path [ file join $directory $experiment $endian ] :name $filename
	    set env(EXPERIMENTDIR) [ file join $directory $experiment ]
	    if { $mydebug == 1 } then { puts "check_experiment: Tempory experiment has been joined" }
	}
	after 1000
	splash_update "Tempory experiment has been Joined ... "
	after 1000
	splash_update "Informing MIDAS-Session about new experiment .."
	#--> Send a message to the logger so that we know where we are "
	insert-log "MIDASsort-> Created & Joined temporary experiment"
	#--> Now tell the rest of the session what we have done ...
	foreach task [ Get_Task_Names ] {
	    if {[inform $task "info procs set-experiment"] == "set-experiment"} then {
		if { $mydebug == 1 } then { puts "check_experiment : informing $task set-experiment" }
		inform $task set-experiment [file join $directory $experiment]
	    }
	}

	set userexpt 1
    } else {
	if { $mydebug == 1 } then { puts "check_experiment: Valid Expt" }
	splash_update "Valid Experiment set ..."
	after 1000
    }
    
}