#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> compile_sortfile.tcl                                    <--#
#-->                                                         <--#
#--> This routine compiles your sort program.                <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc compile_sortfile args {
    global env sortfilename compileoptions execfilename
    global file_status
    global makefilepath
    global mydebug
    global usegcc
    global usesssnc

    :modify LIST :empty T
    update idletasks

    set co1 ""
    set co2 ""
    set co3 ""
    set co4 ""

    if { $mydebug == 1 } then {
	puts "compile_midas_sort $sortfilename"
    }
    
    if { $usegcc == 1 } then {
	if { $mydebug == 1 } then {
	    puts "using gcc compiler"
	}
	set co1 "-usegcc"
    }

    if { $usesssnc == 1 } then {
	if { $mydebug == 1 } then {
	    puts "using Sunsort spectrum nameing convention"
	}
	set co2 "-usesssnc"
    }
    
    set rc [catch { exec compile_midas_sort $sortfilename $co1 $co2 "-mkfile" $makefilepath $compileoptions } m]    

    set response "$m"
    if {$rc != 0} then {
	abort_report
    }

    insert-list $m

    set rc [catch { exec filestatus_midas_sort $sortfilename } m]

    switch $m {
	0     { set file_status "To BE Compiled" }
	1     { set file_status "Compiled"}
	2     { set file_status "Exe file older than src" }
    }

    :modify STATE :label $file_status

}
