#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for Sunsort                             <--#
#-->                                                         <--#
#--> Debug Info Frame                                        <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 07/15/03                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc debug_options args {
    global sigforce
    global debuglevel

    :frame FDEBUGO :label "Debug Levels" \
	:resize F :transient T
     :panel PDEBUGO :layout V  :padx 5 :pady 5
      :layout H
      :message MDEBUGO :label "MIDASsort: Debug Level control frame" :bold T
      :next-row T
      :next-row T
      :checkbox CBDOALL :label "All Debug statements" :value $debuglevel(all)
      :next-row T
      :next-row T
      :message MDEBUGO1 :label "User Debug Levels" :bold T
      :next-row T
      :checkbox CBDOU0  :label "All" :value $debuglevel(user0) :valuex 7c
      :hskip 10
      :checkbox CBDOU1  :label "User1" :value $debuglevel(user1) :valuex 7c
      :hskip 10
      :checkbox CBDOU2  :label "User2" :value $debuglevel(user2) :valuex 7c
      :hskip 10
      :checkbox CBDOU3  :label "User3" :value $debuglevel(user3) :valuex 7c
      :hskip 10
      :checkbox CBDOU4  :label "User4" :value $debuglevel(user4) :valuex 7c
      :hskip 10
#      :checkbox CBDOU5  :label "User5" :value $debuglevel(user5) :valuex 7c
#      :hskip 10
#      :checkbox CBDOU6  :label "User6" :value $debuglevel(user6) :valuex 7c
#      :hskip 10
#      :checkbox CBDOU7  :label "User7" :value $debuglevel(user7) :valuex 7c
#      :hskip 10
#      :checkbox CBDOU8  :label "User8" :value $debuglevel(user8) :valuex 7c
#      :hskip 10
#      :checkbox CBDOU9  :label "User9" :value $debuglevel(user9) :valuex 7c
#      :hskip 10
      :next-row T
      :message MDEBUGO2 :label "Library Debug Levels" :bold T
      :next-row T
      :checkbox CBDOL0  :label "All" :value $debuglevel(sortcalls) :valuex 7c
      :hskip 10
      :checkbox CBDOL1  :label "Inc1d" :value $debuglevel(inc1d) :valuex 7c
      :hskip 10
      :checkbox CBDOL2  :label "Inc2d" :value $debuglevel(inc2d) :valuex 7c
      :hskip 10
      :checkbox CBDOL3  :label "ConvID" :value $debuglevel(ucid) :valuex 7c
      :hskip 10
      :checkbox CBDOL4  :label "Gmatch" :value $debuglevel(ugm) :valuex 7c
      :hskip 10
      :checkbox CBDOL5  :label "Hist" :value $debuglevel(ugm) :valuex 7c
      :hskip 10
      :next-row T
      :message MDEBUGO3 :label "Main Sort Debug Levels" :bold T
      :next-row T
      :checkbox CBDOMS0  :label "All" :value $debuglevel(maina) :valuex 7c
      :hskip 10
      :checkbox CBDOMS6  :label "Main" :value $debuglevel(main) :valuex 7c
      :hskip 10
      :checkbox CBDOMS5  :label "Parse" :value $debuglevel(parse_args) :valuex 7c
      :hskip 10
      :checkbox CBDOMS1  :label "Spectra" :value $debuglevel(spectra) :valuex 7c
      :hskip 10
      :checkbox CBDOMS4  :label "Getblk" :value $debuglevel(get_block) :valuex 7c
      :hskip 10
      :checkbox CBDOMS3  :label "Decipher" :value $debuglevel(decipher) :valuex 7c
      :hskip 10
      :checkbox CBDOMS7  :label "Shared" :value $debuglevel(shared) :valuex 7c
      :hskip 10
      :next-row T
      :checkbox CBDOMS2  :label "Final" :value $debuglevel(end_prog) :valuex 7c
      :hskip 10
      :checkbox CBDUI  :label "Uint" :value $debuglevel(uinteract) :valuex 7c
      :hskip 10
      :checkbox CBGAT  :label "Gate" :value $debuglevel(gate) :valuex 7c
      :hskip 10
      :next-row T
#      :message MDEBUGTB :label "Trace back - Experts only please!" :bold T
#      :next-row T
#      :checkbox CBTB    :label "Enable" :value $debuglevel(tback) :valuex 7c
#      :next-row T
      :next-row T
      :hskip 700
      :button BDOSO :label "Save Debug levels" 

    :show T
      
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setalld arg {
    global sigforce
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
	puts "setalld : arg = $arg"
    }

    set searchid [ array startsearch debuglevel ]
    while { [ array anymore debuglevel $searchid ] } {
	set element [ array nextelement debuglevel $searchid ]
	set debuglevel($element) $arg
    }
    array donesearch debuglevel $searchid

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setuserd arg {
    global sigforce
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
	puts "setuserd : arg = $arg"
    }

    for { set i 0 } { $i < 10 } { incr i } {
	set val user$i
	set debuglevel($val) $arg
	if { $mydebug == 1 } then {
	    puts "debuglevel($val) = $debuglevel($val)"
	}
    }

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setlibd arg {
    global sigforce
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
	puts "setlibd : arg = $arg"
    }

    set debuglevel(sortcalls) $arg
    set debuglevel(inc1d) $arg
    set debuglevel(inc2d) $arg
    set debuglevel(ucid) $arg
    set debuglevel(ugm) $arg
    set debuglevel(hist) $arg
    set debuglevel(gate) $arg

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc setmaind arg {
    global sigforce
    global debuglevel 
    global mydebug
    
    if { $mydebug == 1 } then {
	puts "setmaind : arg = $arg"
    }

    set debuglevel(maina) $arg
    set debuglevel(main) $arg
    set debuglevel(spectra) $arg
    set debuglevel(end_prog) $arg
    set debuglevel(decipher) $arg
    set debuglevel(get_block) $arg
    set debuglevel(parse_args) $arg
    set debuglevel(shared) $arg

    modify_dlevel 0

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc modify_dlevel arg {
    global sigforce
    global debuglevel

    :modify CBDOALL :value $debuglevel(all)
    :modify CBDOU0 :value $debuglevel(user0)
    :modify CBDOU1 :value $debuglevel(user1)
    :modify CBDOU2 :value $debuglevel(user2)
    :modify CBDOU3 :value $debuglevel(user3)
    :modify CBDOU4 :value $debuglevel(user4)
#    :modify CBDOU5 :value $debuglevel(user5)
#    :modify CBDOU6 :value $debuglevel(user6)
#    :modify CBDOU7 :value $debuglevel(user7)
#    :modify CBDOU8 :value $debuglevel(user8)
#    :modify CBDOU9 :value $debuglevel(user9)
    :modify CBDOL0 :value $debuglevel(sortcalls)
    :modify CBDOL1 :value $debuglevel(inc1d)
    :modify CBDOL2 :value $debuglevel(inc2d)
    :modify CBDOL3 :value $debuglevel(ucid)
    :modify CBDOL4 :value $debuglevel(ugm)
    :modify CBDOL5 :value $debuglevel(hist)
    :modify CBDOMS0 :value $debuglevel(maina) 
    :modify CBDOMS6 :value $debuglevel(main) 
    :modify CBDOMS1 :value $debuglevel(spectra) 
    :modify CBDOMS2 :value $debuglevel(end_prog) 
    :modify CBDOMS3 :value $debuglevel(decipher) 
    :modify CBDOMS4 :value $debuglevel(get_block) 
    :modify CBDOMS5 :value $debuglevel(parse_args) 
    :modify CBDOMS7 :value $debuglevel(shared) 
    :modify CBDUI   :value $debuglevel(uinteract) 
    :modify CBGAT   :value $debuglevel(gate) 

    update idletasks
}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc save_debug_levels {} {
    global sigforce
    global debuglevel
    global mydebug
    global debugsort
    global running

    set z [ catch { open "debug.info" w } f ]
    if { $z == 0 } then {
	set searchid [ array startsearch debuglevel ]
	while { [ array anymore debuglevel $searchid ] } {
	    set element [ array nextelement debuglevel $searchid ]
	    if { $mydebug == 1 } then {
		puts "$element = $debuglevel($element)"
	    }
	    if {$z != 0} then {
		midas-warning "Unable to write file debug.info\n$f"
		return
	    } else {
		puts $f "$element $debuglevel($element)"
	    }
	}
	array donesearch debuglevel $searchid
	
	close $f

	if { $running == 1 } then {
	    if { $debugsort == 1 } then {
#		set rc [catch { exec shmctrl 1 w 1 } m]
		set rc [catch { exec midasSortshm w 2 1 } m]
	    }
	}
    }
    destroy-frame FDEBUGO
    
    

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> set the debug level for the sort                        <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc debug_level arg {
    global sigforce
    global debugsort
    global running
    global mydebug

    set debugsort $arg

    if { $mydebug == 1 } then { puts "debug_level : debugsort = $debugsort " }
    if { $mydebug == 1 } then { puts "debug_level : running   = $running " }
    if { $mydebug == 1 } then { puts "debug_level : sigforce  = $sigforce " }

    if { $debugsort == 0 } then {
	:modify BDSO :inactive T
    } else {
	:modify BDSO :inactive F
    }
    update idletasks

    if { $running == 1 } then {
	if { $debugsort == 0 } then {
	    if { $sigforce == 1 } then {
		set rc [catch { exec smf-debugsig 0 } m]
	    } else {
#		set rc [catch { exec shmctrl 1 w 0 } m]
		set rc [catch { exec midasSortshm w 2 0 } m]
	    }
	} else {
	    if { $sigforce == 1 } then {
		set rc [catch { exec smf-debugsig 1 } m]
	    } else {
#		set rc [catch { exec shmctrl 1 w 1 } m]
		set rc [catch { exec midasSortshm w 2 1 } m]
	    }
	}
    } 

}