#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for Sunsort                             <--#
#-->                                                         <--#
#--> Options   frame                                         <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 06/30/03                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Sort_options GUI frame ......                           <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc sort_options {} {
    global env makefilepath mydebug
    global debugsort dsize
    global mydebug
    global running
    global soopened
    global update
    global tracesort tracelevel

    set soopened 1

    :frame FSOPT :label "MIDASSort: Sort Options" \
	:resize F :transient T
     :panel PFSO :layout V  :padx 5 :pady 5
      :layout H
      :message MFSO :label "MIDASsort: Sort options control frame" :bold T
      :next-row T
      :next-row T
#      :choice-stack CSDSO :label "Debug Sort" \
#	:value $debugsort :strings "Off On" \
#	:valuex 80
       :checkbox CSDSO :label "Debug Sort" \
	:value $debugsort \
	:valuex 80
      :hskip 48
      if { $debugsort == 0 } then {
	  :button BDSO :label "Debug Levels" :inactive T 
      } else {
	  :button BDSO :label "Debug Levels" :inactive F 
      }
      :next-row T
      :checkbox CBTO :label "Enable Trace" \
	      :value $tracesort \
	      :valuex 80
      :hskip 48
      if { $tracesort == 0 } then {
	  :choice-stack CSTO :label "Trace Sort Level" :inactive T \
		  :strings "0 1 2 3 4 5" \
		  :value $tracelevel
      } else {
	  :choice-stack CSTO :label "Level" :inactive F \
		  :strings "0 1 2 3 4 5" \
		  :value $tracelevel
      }
      :next-row T
      :next-row T
      :button BCFTAB    :label "User Variables"       :w 18
      :hskip 10
      if { $running == 0 } then {
        :button BGMTAB    :label "Gainmatching"       :w 12
      } else {
        :button BGMTAB    :label "Gainmatching"       :w 12 :inactive T
      }
      :next-row T
      if { $running == 0 } then {
        :button BGATETAB  :label "Gating"             :w 18
      } else {
        :button BGATETAB  :label "Gating"             :w 18 :inactive T
      }
      :hskip 10
      :button BVDATA    :label "View RawData"       :w 12

      :next-row T
      :next-row T
      :choice-stack CSDDSO :label "Update delay (s)  " \
	:value $update :strings "1 5 10 30 60 120 300 600" \
	:inactive F
      :next-row T

    :show T
}

proc enable_set_trace { toggle } {
    global mydebug
    global tracesort tracelevel


    if { $toggle == 0 } then {
	set tracesort 0
	:modify CSTO :inactive T
	if { $mydebug == 1 } then { puts "enable_set_trace: tracesort set to $toggle" }
    } else {
	set good [ midas-confirmation "Are you sure you want to enable TRACE?\nThis could result in a very LARGE log file!" ]
	if { $good == 1 } then {
	    set tracesort 1
	    :modify CSTO :inactive F
	    if { $mydebug == 1} then { puts "enable_set_trace: tracesort enabled!\n" }
	} else {
	    if { $mydebug == 1 } then { puts "enable_set_trace: tracesort left unchanged (=$tracesort)" }
	    set tracesort 0
	    :modify CSTO :inactive T
	    :modify CBTO :value $tracesort
	}
    }

    write_trace
}

proc set_trace_level { level } {
    global mydebug
    global tracesort tracelevel

    set tracelevel $level
    if { $mydebug == 1 } then { puts "enable_set_trace: tracelevel set to $level" }

    write_trace

}

proc write_trace { } {
    global mydebug
    global tracesort tracelevel

    if { $mydebug == 1 } then { puts "write_trace: Routine entered" }

    #--> check that the values are sensible ..
    if { $tracesort == 0 || $tracesort == 1 } then {
	if { $tracelevel >= 0 && $tracelevel < 6 } then {
	    set rc [ catch { exec midasSortshm w 30 $tracesort } m ]
	    set rc [ catch { exec midasSortshm w 31 $tracelevel } m ]
	} else {
	    if { $mydebug == 1 } then { puts "write_trace: bad value of tracelevel (==$tracelevel)" }
	}
    } else {
	if { $mydebug == 1 } then { puts "write_trace: bad value of tracesort (==$tracesort)" }
    }

    if { $mydebug == 1 } then { puts "write_trace: Leaving ..." }

}