#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> Splash screen so the user knows what is going on ...    <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc splash_create { image product copyright msg } {
    global tcl_version tk_version tcl_platform
    global tcl_patchLevel

    #--> If a splash screen exists we shall remove it 
    splash_remove
    toplevel .splash
    wm withdraw .splash
    #--> Center on screen
    splash_dialog_position .splash
    #--> Top area contains info
    set frm .splash.top
    frame $frm -bd 2 -relief groove
    #--> The image we shall display
    label $frm.logo -image $image
    #--> Label for product version number
    label $frm.product -text "$product"
    #--> message widget
    message $frm.copyright -text "$copyright" -width 3i
    #--> Label for OS version
    label $frm.osversion -text "$tcl_platform(os) $tcl_platform(osVersion)"
    #--> Layout
    pack $frm.logo -side top -fill x -pady 4 -ipadx 4 -ipady 4
    pack $frm.product $frm.copyright $frm.osversion -side top -fill x
    pack $frm -side top -fill x -padx 8 -pady 8
    #--> Bottom area contains the current message
    set frm .splash.bottom
    frame $frm -bd 2 -relief groove
    label $frm.msg -text "$msg" -anchor w
    pack $frm.msg -side left -ipadx 6 -ipady 4
    pack $frm -side bottom -fill x -padx 8 -pady 8
    wm deiconify .splash
    update
}

proc splash_update { msg } {
    set name .splash.bottom.msg

    if { [ winfo exists $name ] } then {
	$name config -text "$msg"
	update
    }
}

proc splash_remove { } {
    if { [ winfo exists .splash ] } then {
	destroy .splash
    }
}

proc splash_dialog_position { dlg } {
    set width  [ winfo screenwidth . ]
    set height [ winfo screenheight . ]

    set x [ expr ($width / 2 )  - 260 ]
    set y [ expr ($height / 2 ) - 260 ]

    wm geometry $dlg +$x+$y

}
