#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> status.tcl                                              <--#
#-->                                                         <--#
#--> This routine determine the status of the system         <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
proc status {} {
    global running
    global paused
    global mydebug

#--> The status of the sort program can be obtained from the
#--> file sort.status in the tmp dir in which we are running.
    set z [ catch { open "sort.status" r } f ]
    if { $z != 0 } then {
	#--> As we can not read the file, the sort can not be running
	set running 0
    } else {
	gets $f "$running"
	close $f
    }

    if { $running == 0 } then {
	:modify MSRSTATE :label "NOT running"
	:modify BSTART :inactive F
	:modify BSTOP :inactive F
    } elseif { $running == 1 } then {
	:modify MSRSTATE :label "Running"
	if { $paused == 1 } then {
	    :modify MSRSTATE :label "Paused"
	}
    }

    update idletasks

}