#------------------------------------------------------------------------OLCM
set OLCM(frame-name) OLCM
set OLCM(frame-title) "Overlapping Line Colours"
set OLCM(icon-title) optOLCM

set MAXOVERLAPS 16

set preferences(OLCM.colours) {black red blue green yellow magenta cyan #808080 #404040 \
                               #c0c0c0 #000040 #000080 #0000c0 #800080 #008080 #808000}
set OLCM(defaults) $preferences(OLCM.colours)

set tkColorDialogLayout H

proc OLCM.make-frame {} {
   global env preferences MAXOVERLAPS OLCM

   set OLCM(defaults) $preferences(OLCM.colours)

  :frame $OLCM(frame-name) :label "$OLCM(frame-title)" :show-footer F :toplevel T \
        :icon-image "@$env(ICONHOME)/spectrum"  \
           :icon-name $OLCM(icon-title) :resize F

  :panel OLCM-PANEL :layout T
    :layout H
 
    for {set i 0} {$i < $MAXOVERLAPS} {incr i} {
       :canvas OLCM-SAMPLE$i :w 30 :h 60 :x [expr 30 * $i] :y 0
       :draw rectangle :tag S$i :colour [lindex $preferences(OLCM.colours) $i] :value 5 5 25 60
       [:path OLCM-SAMPLE$i] bind all <ButtonRelease-1> "OLCM-set-linecell $i"
       [:path OLCM-SAMPLE$i] bind all <ButtonRelease-3> "OLCM-take-linecell $i"
    }

   :panel OLCM-COLORSELECTION :padx 5 :pady 5 :layout T

  tkColorDialog [:path OLCM-COLORSELECTION]

  :panel OLCM-BUTTONS :layout B :padx 10
    :layout H; :col-gap 25

    :button OLCM-RESET  :label Reset                 :command reset-linecolours
    :button OLCM-SAVE   :label "Save preferences"  :command update_preferences
    :button HELP

  :show T
}

proc OLCM-set-linecell {b} {
   global preferences
   global data               #  data interchange with tkColorDialog
   set OLCMcell $b
   set rgb $data(selection)
   [:path OLCM-SAMPLE$OLCMcell] itemconfigure S$b -fill $rgb
   set preferences(OLCM.colours) [lreplace $preferences(OLCM.colours) $OLCMcell $OLCMcell $rgb]
   inform sd set-linecolourmap [transparent $preferences(OLCM.colours)]
}

proc OLCM-take-linecell {b} {
   global preferences
   global w              #  data interchange with tkColorDialog
    set colour [lindex $preferences(OLCM.colours) $b]
    set rgb [winfo rgb . $colour]
    set r [expr [lindex $rgb 0]/0x100]
    set g [expr [lindex $rgb 1]/0x100]
    set b [expr [lindex $rgb 2]/0x100]
    tkColorDialog_SetRGBValue $w [list $r $g $b]
}
proc reset-linecolours {} {
   global preferences OLCM MAXOVERLAPS
   set preferences(OLCM.colours) $OLCM(defaults)
   for {set i 0} {$i<$MAXOVERLAPS} {incr i 1} {
     [:path OLCM-SAMPLE$i] itemconfigure S$i -fill [lindex $preferences(OLCM.colours) $i]
   }
   set preferences(OLCM.colours) [lreplace $preferences(OLCM.colours) 0 0 [first $preferences(OLCM.colours)]]
   inform sd set-linecolourmap [transparent $preferences(OLCM.colours)]
}   

proc OLCM.save {} {}
proc OLCM.repaint {} {}
proc OLCM.announce {} {}

