# centrum module frame
#    sept 2001   VP

set debug 0
set started 0

set frame Centrum
set frametitle "Centrum Module Control"
set icontitle Centrum


set cardtype Centrum
set VXIGlobal ""
set chantype ""

#    frametype = 0  (standard) or 1 (expert)
set frametype 0

set chanlist {???}
set chanindex 0

set defaultchanlist {0}


#    The array "table" which is indexed by the "widget name" contains all the information
#    needed for the register/display item
#
#    Each element of "table" is a list
#


set table(MODELCODE)   {rw "VXI.ModelCode"}
set table(MANID)       {rw "VXI.ManID"}
set table(OFFSET)      {rw "VXI.Offset"}
set table(MODID)       {rw "VXI.ModID"}
set table(PASSED)      {rw "VXI.Passed"}
set table(READY)       {rw "VXI.Ready"}
set table(RESET)       {rw "VXI.Reset"}
set table(A24A32)      {rw "VXI.A24A32"}
set table(ADDRSPACE)   {rw "VXI.AddrSpace"}
set table(DEVCLASS)    {rw "VXI.DevClass"}
set table(REQMEM)      {rw "VXI.ReqMem"}
set table(SERNUM)      {rw "VXI.SerialNum"}
set table(MODLVL)      {rw "VXI.ModLevel"}
set table(STATUS)      {rw "VXI.Status"}
set table(CODING)      {rw "VXI.Coding"}
set table(READOUT)     {rw "VXI.Readout"}
set table(INIT)        {rw "VXI.Init"}
set table(GO)          {rw "VXI.Go"}
set table(MRST)        {rw "VXI.MRST"}
set table(VALIDATION)  {rw "VXI.Val"}
                     
set table(EXO)        {rw "config.exo"}
set table(TEN)        {rw "config.ten"}
set table(CALI)       {rw "config.cali"}
set table(ZS)         {rw "config.zs"}
set table(DT32)       {rw "config.dt32"}
set table(DTF)        {rw "config.dtf"}
set table(MIE)        {rw "config.mie"}
set table(SAMR)       {rw "config.samr"}

                     
set table(RX)         {rw "mask.rx"}
foreach i {1 2 3 4 5 6 7}   {set table(TX$i)         "rw \"mask.tx$i\""}
set table(AUX)        {rw "mask.aux"}
foreach i {1 2 3 4 5 6 7}   {set table(LCH$i)         "rw \"mask.lch$i\""}
foreach i {1 2 3 4 5 6 7}   {set table(COR$i)        "rw \"txmode.cor$i\""}
foreach i {1 2 3 4 5 6 7}   {set table(SA$i)         "rw \"txmode.sa$i\""}
foreach i {H M L}           {set table(LOADCLK$i)    "rw  \"loadclk[string tolower $i]\""}
foreach i {H M L}           {set table(LOADTI$i)     "rw  \"loadti[string tolower $i]\""}
foreach i {1 2 3 4 5 6 7}   {set table(DELTAG$i)     "rw  \"deltag$i\""}
foreach i {H L}             {set table(LABELEVNUM$i) "rw \"label.evnum.[string tolower $i]\""}
foreach i {H M L}           {set table(LABELRX$i)    "rw   \"label.rx.[string tolower $i]\""}
set table(LABELMISS)        {rw "label.miss"}
foreach c {SCOD ECOD READ CLKS ERR TOUT}                  {set table(S$c)       "rw \"status.[string tolower $c]\""}                       
foreach c {RESET EVCR RCLK LCLK LTIM RERR PULL PUL2 UCLK} {set table(C$c)       "rw \"cmd.[string tolower $c]\""}
       
foreach k {1 2 3 4 5 6 7} {    
foreach i {H M L} {
set table(LABELTX$k$i)   "rw  \"label.tx$k.[string tolower $i]\""
}}
              
set table(EVCNT)    {ro  "evcnt"}
set tabke(MISSEVTS) {ro  "MissEvts"}
foreach k {0 1 2 3 4 5 6 7} {    
foreach i {H ML} {
set table(TIME$i$k)   "rw \"time[string tolower $i]$k\""
}}

set table(TEST1SEL)  {wo  "test1"}
set table(TEST2SEL)  {wo  "test2"}
set table(MISSOVF)   {rw  "MissOvf"}

set table(DATA)   {rw  "data"}


set testinspmenu [list NIM_level_0 TAG1 TAG2 TAG3 TAG3 TAG5 TAG6 TAG7 \
    RTAG RUN/STOP START_CLOCK VAL*_or_CKEVT internal_CODING \
    internal_READOUT MRST* NIM_level_1 PULSEn undefined undefined undefined undefined \
    LDTACK* LBERR* AS* WE* LWORD* IACK* DS0" DS1* DTACK* BERR* LI]

                     
loadsource common.vxi

#    register selection for parameter save function

set registersavepatterns {
    VXI.Coding VXI.Readout VXI.Init VXI.Go VXI.MRST config mask txmode loadclk? loadti? deltag?
    label.evnum.? label.rx.? label.tx[1-7].? label.miss MissOvf
}

proc centrum_status {} {
   global resource
   eg "(register :name '/$resource/Centrum0.VXI.Status' ?value)"
}

proc read-vxi-reg {register} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister  /$resource/$cardtype$chan.$register
   EG "register :name '$VXIregister' ?value"
}

proc read-vxi-regs {register} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister  /$resource/$cardtype$chan.$register
   EG "register :pattern '$VXIregister' ?names-and-values"
}

proc write-vxi-reg {register value} {
   global resource cardtype chanindex chanlist VXIregister
   set chan [lindex $chanlist $chanindex]
   set VXIregister /$resource/$cardtype$chan.$register
   EG "register :name '$VXIregister' :value '$value'"
}

proc click-redisplay {} {
   global table testinspmenu EGreport

   set EGreport_SAVE $EGreport
   set EGreport -1

   set-busy
   
   foreach w [array names table] {update-widget $w}

   if {[catch {:modify $TEST1SIG :label ""}] == 0} {
       :modify TEST1SIG :label [lindex $testinspmenu [read-vxi-reg test1]]
       :modify TEST2SIG :label [lindex $testinspmenu [read-vxi-reg test2]]
   }

   clear-busy
   set EGreport $EGreport_SAVE
}

proc update-widget {w} {
    global table 

       set item $table($w)
       set access [lindex $item 0]
       set register [lindex $item 1]

       if {$access == "wo"} then {return}
       if {[:query_widget $w] == 0} then {return}

       if {[catch {:modify $w :value 0}] != 0} {return}

       set vl [read-vxi-reg $register]
       :modify $w :value $vl
}

proc click-test {w i} {
    global testinspmenu

     click-on TEST[set w]SEL $i
     :modify TEST[set w]SIG :label [lindex $testinspmenu [read-vxi-reg test[set w]]]
}

proc click-on {w v} {
    global table

    set item $table($w)
    set access [lindex $item 0]
    set register [lindex $item 1]
    
    if {$access == "ro"} {continue}

    write-vxi-reg $register $v
    :modify $w :value [read-vxi-reg $register]
}

proc click arg {
    global debug 
    if {$debug} then {puts stderr "click with argument \{$arg\}"}
    set f [lindex $arg 0]
    set c [lindex $arg 1]
    set w [lindex $arg 2]
    set v [lindex $arg 3]
    set i [lindex $arg 4]
    if {$c==":quit"} then {click-quit $f; return}
    switch $w  {
        CHANNEL      {click-channel $v}
        REDISPLAY    {click-redisplay}
        ENGINEERING  {click-$v}
        RDDATA       {update-widget DATA}
        TEST1SEL     {click-test 1 $i}
        TEST2SEL     {click-test 2 $i}
        default      {click-on $w $v}
    }
}

proc click-readout {} {
#  display readout sub frame
   global readoutvisible readoutframe
   if {$readoutvisible==0} then {make-readout} else {open-frame $readoutframe}
   click-redisplay
}

proc make-frame1 {} {make-standard-frame}

proc do_expert   {} {make-expert-frame; click-redisplay}
proc do_standard {} {make-standard-frame; click-redisplay}

proc make-expert-frame {} {
  global env chanlist chanindex testinspmenu
  global frametype

  set frametype 1

  :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

  :panel PANEL :layout T :padx 10 :pady 10
    :layout H; :col-gap 10; :row-gap 10

  if {[llength $chanlist] > 1} then  { 
     :choice-stack CHANNEL :label "Module:"  :valuex 12c :strings $chanlist :value $chanindex
   :next-row T
  }

     :message M1 :label "general configuration register"  :bold T
     :next-row T
     :col-gap 25
       :checkbox   EXO   :label "EXOGAM mode"
       :checkbox   TEN   :label "Timer enabled"
       :checkbox   CALI  :label "Calibration enabled"
       :checkbox   ZS    :label "zero suppression on"
       :checkbox   DT32  :label "DT32 readout selected"
     :next-row T
       :checkbox   DTF   :label "slave => master TX6-7"
       :checkbox   MIE   :label "Missing events interrupt enable"
       :checkbox   SAMR  :label "Send always mode receiver"
       
     :next-row T
     :message M2 :label "mask register"  :bold T
       :checkbox RX   :label "Rx ON"
       foreach i {1 2 3 4 5 6 7} {
       :checkbox TX$i  :label "Tx$i ON"
       }
     :next-row T
       :hskip 50
       :checkbox AUX  :label "Aux"
       foreach i {1 2 3 4 5 6 7} {
       :checkbox LCH$i  :label "LCh$i ON"
       }
 
      :next-row T
      :message M3  :label "data transmission mode register"  :bold T
      :next-row T
          :message M12 :label "Correlated channel"  :valuex 28c

         :col-gap 8
          foreach i {1 2 3 4 5 6 7} {
          :checkbox COR$i  :label "Ch$i"
          :hskip 22
          }
        :next-row T
          :message M13 :label "Send always"  :valuex 28c
          foreach i {1 2 3 4 5 6 7} {
          :checkbox SA$i  :label "Ch$i"
          :hskip 22
          }

        :next-row T
           :message M10 :label "Delay for TAG input pulse" :valuex 28c
           foreach i {1 2 3 4 5 6 7} {
           :text DELTAG$i :label "Ch$i"  :w 6
           }

        :col-gap 10
        :next-row T
          :message M8 :label "clock counter preload" :bold T :valuex 28c
          :text LOADCLKH  :label "H"   :w 6
          :text LOADCLKM  :label "M"   :w 6
          :text LOADCLKL  :label "L"   :w 6

          :message M9 :label "timer preload" :bold T :valuex 15c
          :text LOADTIH  :label "H"   :w 6
          :text LOADTIM  :label "M"   :w 6
          :text LOADTIL  :label "L"   :w 6
          
        :next-row T
          :text MISSOVF  :label "Missed events threshold" :w 6 :valuex 28c
                  
        :next-row T
          :message M4 :label "data label for compression mode" :bold T
          :col-gap 10
         :next-row T
           :text LABELEVNUMH :label "event number    H" :w 6  :valuex 20c
           :text LABELEVNUML :label "L" :w 6
           
           :hskip 90
           
           :text LABELRXH :label "Rx    H" :w 6 :valuex 14c
           :text LABELRXM :label "M" :w 6
           :text LABELRXL :label "L" :w 6
           
         :next-row T
         foreach i {1 2 3} {
           :text LABELTX[set i]H :label "Tx Ch$i    H" :w 6 :valuex 10c
           :text LABELTX[set i]M :label "M" :w 6
           :text LABELTX[set i]L :label "L" :w 6
         }
        
         :next-row T
         foreach i {4 5 6} {
           :text LABELTX[set i]H :label "Tx Ch$i    H" :w 6 :valuex 10c
           :text LABELTX[set i]M :label "M" :w 6
           :text LABELTX[set i]L :label "L" :w 6
         }

         :next-row T
         foreach i {7} {
           :text LABELTX[set i]H :label "Tx Ch$i    H" :w 6 :valuex 10c
           :text LABELTX[set i]M :label "M" :w 6
           :text LABELTX[set i]L :label "L" :w 6
         }
         
         :text LABELMISS :label "Missed events" :w 6 
                    
         :next-row T
            :col-gap 0
            :message M6 :label "status" :bold T :w 8
            :checkbox SSCOD :label "CODing* asserted"      :deaf T :valuex 20c
            :checkbox SECOD :label "CODing* deasserted"    :deaf T :valuex 20c
            :checkbox SREAD :label "VXI Readout asserted"  :deaf T :valuex 20c
            :checkbox SCLKS :label "clock running"         :deaf T :valuex 18c
            :checkbox SERR  :label "event number error"    :deaf T :valuex 18c
            :checkbox STOUT :label "time-out"              :deaf T :valuex 10c
         :next-row T
            :message M7 :label "control" :bold T :w 8
            :checkbox CRESET :label "data readout reset"  :valuex 20c
            :checkbox CEVCR  :label "event counter reset" :valuex 20c
            :checkbox CRCLK  :label "clock counter reset" :valuex 20c
            :checkbox CLCLK  :label "load clock counter " :valuex 18c
         :next-row T
            :message M11 :label "" :bold T :w 8
            :checkbox CLTIM  :label "load timer counter" :valuex 20c
            :checkbox CRERR  :label "EvNum Err reset"    :valuex 20c
            :checkbox CPULL  :label "pulse TEST1 output" :valuex 20c
            :checkbox CPUL2  :label "pulse TEST2 output" :valuex 18c
            :checkbox CUCLK  :label "clock enable"       :valuex 18c
         :next-row T
            :message M14 :label "Test and Inspection" :bold T

          :message    TEST1SIG :label ""  :w 20
          :menubutton TEST1SEL :label "1" :menu $testinspmenu
          :message    TEST2SIG :label ""  :w 20
          :menubutton TEST2SEL :label "2" :menu $testinspmenu
         
   :next-row T
     :col-gap 20
      :button REDISPLAY
      :menubutton ENGINEERING :label "Engineering"  :menu [list electronics readout software]
      :hskip 100
      :button HELP
      :hskip 100
      :button STANDARD :label "Switch to standard window" :command do_standard

   :show T

}

proc make-standard-frame {} {
  global env chanlist chanindex testinspmenu
  global frametype

  set frametype 1

  :frame [self frame-name] :label "[self frame-title]" :show-footer T  \
      :icon-image "@$env(ICONHOME)/vxi_module" \
      :icon-name "[self icon-title]" :resize F

  :panel PANEL :layout T :padx 10 :pady 10
    :layout H; :col-gap 8; :row-gap 10

  if {[llength $chanlist] > 1} then  { 
     :choice-stack CHANNEL :label "Module:"  :valuex 12c :strings $chanlist :value $chanindex
   :next-row T
  }
 
     :message M2 :label "mask register"  :bold T
     :next-row T

       :checkbox RX   :label "Receive ON" :valuex 28c
       :next-row T

       :message M23 :label "Transmit ON"  :valuex 28c
       foreach i {1 2 3 4 5 6 7} {
       :checkbox TX$i  :label "Ch$i"
       :hskip 22
       }
       :next-row T
       :message M24 :label "Local ON"  :valuex 28c
       foreach i {1 2 3 4 5 6 7} {
       :checkbox LCH$i  :label "Ch$i"
       :hskip 22
       }
 
      :next-row T
      :message M3  :label "data transmission mode register"  :bold T
      :next-row T
          :message M12 :label "Correlated channel"  :valuex 28c

          foreach i {1 2 3 4 5 6 7} {
          :checkbox COR$i  :label "Ch$i"
          :hskip 22
          }
        :next-row T
          :message M13 :label "Send always"  :valuex 28c
          foreach i {1 2 3 4 5 6 7} {
          :checkbox SA$i  :label "Ch$i"
          :hskip 22
          }

        :next-row T
           :message M10 :label "Delay for TAG input pulse" :valuex 28c
           foreach i {1 2 3 4 5 6 7} {
           :text DELTAG$i :label "Ch$i"  :w 6
           }

        :col-gap 10
        :next-row T
          :message M8 :label "clock counter preload" :bold T :valuex 28c
          :text LOADCLKH  :label "H"   :w 6
          :text LOADCLKM  :label "M"   :w 6
          :text LOADCLKL  :label "L"   :w 6

        :next-row T
          :message M9 :label "timer preload" :bold T :valuex 28c
          :text LOADTIH  :label "H"   :w 6
          :text LOADTIM  :label "M"   :w 6
          :text LOADTIL  :label "L"   :w 6
                            
      :next-row T
     :col-gap 20
      :button REDISPLAY
      :hskip 100
      :button HELP
      :hskip 100
      :button EXPERT :label "Switch to expert window" :command do_expert

   :show T
}


set readoutvisible 0
set readoutframe [self frame-name].readout

proc make-readout {} {
  global readoutvisible readoutframe

  :frame $readoutframe :label "Centrum Readout Registers" :resize F :transient T

  :panel PANEL2 :layout T :padx 10 :pady 10
    :layout H; :col-gap 0; :row-gap 10

            :text EVCNT   :label "event counter" :deaf T :w 12 :valuex 15c
         :next-row T
            :text TIMEH0  :label "Rx"  :deaf T :w 12  :valuex 15c
            :text TIMEML0 :label ""    :deaf T :w 12
             foreach i {1 2 3 4 5 6 7} {
         :next-row T
            :text TIMEH$i  :label "Tx Ch$i"  :deaf T :w 12  :valuex 15c
            :text TIMEML$i :label ""  :deaf T :w 12
             }
         :next-row T
            :text MISSEVTS :label "Missed events count" :deaf T :w 12 :valuex 18c
         
         :next-row T
          :col-gap 10
            :text DATA  :label "data"   :deaf T :w 12 :valuex 18c
            :button RDDATA  :label "read"

  :show T
  set readoutvisible 1
}


set electronicsvisible 0
set electronicsframe [self frame-name].electronics

proc make-electronics {} {
  global electronicsvisible electronicsframe

  :frame $electronicsframe :label "Centrum VXI Registers (A16/D16)" :resize F :transient T

  :panel PANEL1 :layout T :padx 5 :pady 5
    :layout H; :row-gap 5
      :text MANID     :deaf T  :label "Manufacturer ID:" :w 6 :read-only T :valuex 20c
      :text ADDRSPACE :deaf T  :label "Address Space:"   :w 6 :read-only T :valuex 20c
      :text DEVCLASS  :deaf T  :label "Device Class:"    :w 6 :read-only T :valuex 20c

      :next-row T
      :text MODELCODE :deaf T  :label "Model Code:"         :w 6 :read-only T :valuex 20c
      :text REQMEM    :deaf T  :label "Memory Required:"    :w 6 :read-only T :valuex 20c
      
      :next-row T 
      :text STATUS    :deaf T  :label "Status"  :w 6 :read-only T :valuex 20c
      
      :next-row T
      :col-gap 30
      :checkbox RESET   :deaf T   :label "VXI Reset"
      :checkbox PASSED  :deaf T   :label "VXI Passed:"
      :checkbox READY   :deaf T   :label "VXI Ready:"
      :checkbox MODID   :deaf T   :label "VXI ModID:"
      :checkbox A24A32  :deaf T   :label "VXI A32:"

      :next-row T
      :text OFFSET   :deaf T   :label "VXI Offset:"         :w 6 :read-only T :valuex 20c
      :text SERNUM   :deaf T   :label "Serial Num:"         :w 6 :read-only T :valuex 20c
      :text MODLVL   :deaf T   :label "Mod Level:"          :w 6 :read-only T :valuex 20c
      
      :next-row T
      :text CODING    :label "CODing* signal:"  :w 6  :valuex 20c
      :text READOUT   :label "READout* signal:" :w 6  :valuex 20c
      :text INIT      :label "INIT* signal:"    :w 6  :valuex 20c

      :next-row T
      :text GO        :label "GO* signal:"      :w 6  :valuex 20c
      :text MRST      :label "MRST* signal:"    :w 6  :valuex 20c
      :text VALIDATION    :label "VALIDATION* signal:"    :w 6  :valuex 20c

      
  :show T
  set electronicsvisible 1
}

