# crate.tcl---crate layout inspector

# Wed Jul 19 17:35:14 BST 1995, SCL
#   hacked redisplay with specific code for VRE - has no Serial Number register
# Wed Jan 25 17:30:37 GMT 1995, DB
#   substituted $env(EXPBASE) for /eg
# 6-8-93 PHO
#	Clover card added
# 6-11-92 PHO
#	NIM crate layout frame added
# 30-10-92 PHO
#	finds NAM channels
# 9-10-92 PHO
#	Help fully implemented
# 6-10-92 PHO
#	frame gets resources from capability file
#	Redisplay, reconfigure and Help implemented


set debug 0

set crateicon "(:image icon :w 64 :h 64 :bits '[join {
FFFFFFFFFFFFFFF8820820820820820C820820820820820E820820820820820E
FFFFFFFFFFFFFFFE820820820820820EAA8AA6A26A26A26E8A0A20A20A20A20E
AA8AA6A26A26A26E8A0A28AA8AA8AA8EAA8AA0820820820E826A20820820820E
AA6AA6A26A26A26E8A0820220A20A20EAA6AA6A26A26A26EAA6A28AA8AA8AA8E
AA6AA0820820820EAA6A20820820820E826AA6A26A26A26EAA0820A20A20A20E
AA6826A26A26A26EAA6AA8AA8AA8AA8EAA6820820820820E826AA0820820A20E
AA6826A26A26A26E826AA0A20A20A20EAA0826A26A26A26E826AA8AA8AA8AA8E
AA6820820820820E826AA0820820820EAA6826A26A26A26E826820A20A20A20E
AA0AA6A26A26A26EAA6828AA8AA8AA8EAA6AA0820820820EAA6826A26A26A26E
826AA0A20A20A20E926826A26A26A26EAA6AA8AA8AA8AA8E820820820820820E
FFFFFFFFFFFFFFFE820820820820820E820820820820820E820820820820820E
FFFFFFFFFFFFFFFE7FFFFFFFFFFFFFFE3FFFFFFFFFFFFFFE0000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
} ""]')"


set frame CRATE
set title "Crate Layout"
set cratelist {}
set crateindex 0
set maxslot 12
set maxchan 6
set nulserialnum None

set col1 120
set pitch 60

proc quote-list l {
   set ll {}
   foreach f $l {lappend ll [format "'%s'" $f]}
   return $ll
   }

set crateformat "
	(:frame $frame :label '$title' :w [expr $col1+($maxslot+1)*$pitch] :h 260 :resize F :show-footer T
		:icon (:icon :image icon :transparent T :label 'Crate')
	(:panel :x 0 :y 0 :layout H
		(:choice-stack HOST :label 'Crate:' :valuex $col1
			:strings ([quote-list $cratelist]) :value $crateindex)
	:next-row T
		(:message xxx :valuex $col1 :label 'Slot:' :bold T)"

for {set slot 0} {$slot<=$maxslot} {incr slot} {
	set crateformat [concat $crateformat \
		"\n(:message :x [expr $slot*$pitch+$col1] :label '  $slot' :bold T)"]
}
set crateformat [concat $crateformat ":next-row T
	(:message :valuex $col1 :label 'Serial Number:' :bold T)"]
for {set slot 0} {$slot<=$maxslot} {incr slot} {
	set crateformat [concat $crateformat "
		(:message S$slot-SN :x [expr $slot*$pitch+$col1] :label '')"]
}
for {set chan 1} {$chan<=$maxchan} {incr chan} {
	set crateformat [concat $crateformat ":next-row T
		(:message :valuex $col1 :label 'Channel $chan:' :bold T)"]
	for {set slot 0} {$slot<=$maxslot} {incr slot} {
		set crateformat [concat $crateformat "
			(:message S$slot-C$chan :x [expr $slot*$pitch+$col1] :label '')"]
	}
}
set crateformat [concat $crateformat ":next-row T
	(:button REDISPLAY :label 'Redisplay')
	(:button NAM-DISPLAY :label 'NAM Layout...')
	(:button RECONFIGURE :label 'Reconfigure...')
	(:button HELP :label 'Help...' :x [expr $col1+($maxslot+1)*$pitch-60])
	) :show T)"]

set namframe NAM-LAYOUT
set namtitle "NAM/NIM channel layout"
set namvisible 0
set namlist {}
set namindex 0
set maxnimcrate 3
set maxnimchan 7
set pitch 120

set namformat "
($frame (:command-frame $namframe :label '$namtitle' :w [expr $col1+($maxnimcrate+1)*$pitch] :h 290 :pin-in T
	(:panel :x 0 :y 0 :layout H
		(:choice-stack NAM :label 'NAM card:' :valuex $col1
			:strings ([quote-list $namlist]) :value $namindex)
	:next-row T
		(:message :valuex $col1 :label 'NIM Crate:' :bold T)"

for {set nimcrate 0} {$nimcrate<=$maxnimcrate} {incr nimcrate} {
	set namformat [concat $namformat \
		"\n(:message :x [expr $nimcrate*$pitch+$col1] :label '  $nimcrate' :bold T)"]
}
set namformat [concat $namformat ":next-row T
	(:message :valuex $col1 :label 'Crate Number:' :bold T)"]
for {set nimcrate 0} {$nimcrate<=$maxnimcrate} {incr nimcrate} {
	set namformat [concat $namformat "
		(:message N$nimcrate-CN :x [expr $nimcrate*$pitch+$col1] :label '')"]
}
for {set nimchan 0} {$nimchan<=$maxnimchan} {incr nimchan} {
	set namformat [concat $namformat ":next-row T
		(:message :valuex $col1 :label 'Channel $nimchan:' :bold T)"]
	for {set nimcrate 0} {$nimcrate<=$maxnimcrate} {incr nimcrate} {
		set namformat [concat $namformat "
			(:message N$nimcrate-C$nimchan :x [expr $nimcrate*$pitch+$col1] :label '')"]
	}
}
set namformat [concat $namformat ") :show T))"]

set reconframe CRATE-RECON
set reconvisible 0
set directory $env(EXPBASE)/config/frontend
set file ""
set col0 ":valuex 110"

set reconformat "
($frame (:command-frame $reconframe :label 'Crate Reconfiguration' :w 480 :h 130
      :pin-in T
   (:panel :x 0 :y 10 :layout H
      (:text DIRECTORY :label 'Directory:' :w 24 $col0 :value '$directory')
   :next-row T
      (:text FILE :label 'File:' :w 24 $col0 :value '$file')
   :next-row T
      (:text CONFIG :label 'Configuration:' :w 24 $col0 :read-only T)
   :next-row T
      (:button REPAINT :label 'Redisplay')
      (:button EDIT :label 'Edit'
			:menu (:menu EDIT-MENU :strings ('Text Editor' 'Emacs Editor')))
      (:button LOAD :label 'Load'
			:menu (:menu LOAD-MENU :strings ('File' 'Default')))
      (:button RECON-HELP :label 'Help...' :x 250)
      (:list LIST :x 310 :y 0 :rows 6 :list-width 150)
   ) :show T))"

proc first p {lindex $p 0}
proc second p {lindex $p 1}

proc cleardisplay {} {
	global maxchan maxslot serialnum
	clear-footer
	for {set slot 0} {$slot<=$maxslot} {incr slot} {
		set serialnum($slot) ""
		xv "(S$slot-SN :label '')"
		for {set chan 1} {$chan<=$maxchan} {incr chan} {
			xv "(S$slot-C$chan :label '')"
		}
	}
}

proc clearnamdisplay {} {
	global maxnimcrate maxnimchan nimcratenum
	clear-footer
	for {set nimcrate 0} {$nimcrate<=$maxnimcrate} {incr nimcrate} {
		set nimcratenum($nimcrate) ""
		xv "(N$nimcrate-CN :label '')"
		for {set nimchan 0} {$nimchan<=$maxnimchan} {incr nimchan} {
			xv "(N$nimcrate-C$nimchan :label '')"
		}
	}
}

proc find-resource {ps res} {
   set l {}
   set role {}; set name {}; set host {}
   foreach p $ps {
      case [first $p] in {
         name {set name [second $p]}
         role {set role [second $p]}
         host {set host [second $p]}
         default {} 
         }
      }
   if {$role==$res}  then  {set l "$name"}
   return $l
   }

proc make-resource-list {rsl res} {
   set ll {}
   foreach r $rsl {set l [find-resource $r $res]; if {$l!={}} then {
      lappend ll $l}}
   return $ll
   }

proc paint-resources {} {
	global cratelist crateindex

	if {[catch {exec egresources | tr "()" "{}"} m]} then {
		set-footer "no experiment connected!!!"} else {
		set cratelist [make-resource-list $m frontend]}

	xv "(HOST :strings ([quote-list $cratelist]) :value $crateindex)"
}

proc get-nam-list {} {
	global namlist namindex namsnum

	set namlist {}
	set snumlist {}
	set z [catch {eg "(register :pattern '/frontend/NAM?.VXI.SerialNum' ?names-and-values)" } list]
	if {!$z} then {
		foreach pair $list {
			lappend namlist [first [split [first $pair] .]]
			lappend snumlist [second $pair]
		}
	}
	set namsnum [lindex $snumlist $namindex]
	xv "(NAM :strings ([quote-list $namlist]) :value $namindex)"
}

proc nam-redisplay {} {
	global namlist namindex namsnum nimcratenum

set-footer "nam redisplay"

	clearnamdisplay
	get-nam-list

	set z1 [catch {eg "(register :pattern '/frontend/NAM.*.VXI.SerialNum' ?names-and-values)" } snumlist]
	set z2 [catch {eg "(register :pattern '/frontend/NAM.*.Select' ?names-and-objects)" } atrlist]
	if {!$z1 && !$z2} then {
		foreach pair $snumlist {
			set reg [first $pair]
			set chan [string range $reg 4 [string first .VXI $reg]]
			set snum($chan) [second $pair]
		}
		foreach pair $atrlist {
			set reg [first $pair]
			set chan [string range $reg 4 [string first .Select $reg]]
			if {$snum($chan)==$namsnum} then {
				set bit [get-attrib [second $pair] -b]
				set offset [get-hex-attrib [second $pair] -o]
				if {$offset>=0x80} then {
					set nim [expr ($offset-0x80)/0x20]
					xv "(N$nim-C$bit :label '[string trimright $chan .]')"
					if {$nimcratenum($nim)==""} {
						set z [catch {eg "(register :name '/frontend/NAM.[set chan]LED' ?value)" } nimnum]
						if {$z==0} then {
							set nimcratenum($nim) '\ \ $nimnum'
							xv "(N$nim-CN :label $nimcratenum($nim))"
						}
					}
				}
			}
		}
	}
}

proc redisplay {} {
	global cratelist crateindex serialnum nulserialnum

	cleardisplay
	paint-resources
	set host [lindex $cratelist $crateindex]

# get attributes for resource manager roco (or VRE) and trigger and nam

	set z [catch {eg "(register :pattern '/$host/\[N,R,V,T]*.VXI.ManID' ?names-and-objects)" } list]
	if {$z==0} then {
		foreach pair $list {
			set label [trunc [first $pair]]
			set slot [get-attrib [second $pair] -s]
			if {$slot>=0} {
				xv "(S$slot-C1 :label '$label')"
				if {[string range $label 0 2] == "VRE"} then {
                                   set z [catch {set snum $nulserialnum}]
				} else {
				   set z [catch {eg "(register :name '/$host/$label.VXI.SerialNum' ?value)" } snum]
                                }
				if {$z==0} then {
					set serialnum($slot) '[string trimleft [string trimleft $snum 0] x]'
					xv "(S$slot-SN :label $serialnum($slot))"
				}
			}
		}
	}

# get attributes for bgo and germanium and clover

	set z [catch {eg "(register :pattern '/$host/\[Ge?,Ge??,BGO?,BGO??,Clover??.GeA].ROCITest' ?names-and-objects)"} list]
	if {$z==0} then {
		foreach pair $list {
			set label [trunc [first $pair]]
			set slot [get-attrib [second $pair] -s]
			set chan [get-attrib [second $pair] -c]
			if {$slot>=0} {
				xv "(S$slot-C$chan :label '$label')"
				if {$serialnum($slot)==""} {
					set z [catch {eg "(register :name '/$host/$label.VXI.SerialNum' ?value)" } snum]
					if {$z==0} then {
						set serialnum($slot) '[string trimleft [string trimleft $snum 0] x]'
						xv "(S$slot-SN :label $serialnum($slot))"
					}
				}
			}
		}
	}
}

proc click-help {} {
	clear-footer
	send mb goto [transparent "Crate Layout"]
}

proc click-recon-help {} {
	clear-footer
	send mb goto [transparent "Crate Reconfiguration"]
}

proc click-quit f {
	global reconvisible namvisible
	xv "($f :delete)"

	case $f in {
		NAM-LAYOUT  {set namvisible 0}
		CRATE-RECON {set reconvisible 0}
		default     {set namvisible 0; set reconvisible 0}
	}
}


proc click-redisplay {} {
	global reconvisible namvisible
	if {$reconvisible} then {click-repaint}
	redisplay
	if {$namvisible} then {nam-redisplay}
}

proc click-host v {
	global rackcratelist crateindex
	set crateindex $v
	click-redisplay
}

proc click-nam v {
	global namindex
	set namindex $v
	nam-redisplay
}

proc strip-to-dot s {string range $s [expr 1+[string first . $s]] end }

proc trunc r {
   set i [string first "." $r]
   if {$i<0} then {return $r}
   incr i -1
   return [string range $r 0 $i]
   }

proc get-attrib {string id} {
	set i [string first $id $string]
	if {$i<0} then {return -1}
	scan [string range $string $i end] "$id%d" slot
	return $slot
}

proc get-hex-attrib {string id} {
	set i [string first $id $string]
	if {$i<0} then {return -1}
	scan [string range $string $i end] "[set id]0x%x" slot
	return $slot
}

proc dirnames l {
   foreach f $l {lappend ll [first $f]}
   return $ll
   }

proc strip-dots l {
   foreach n $l {if {$n!="." && $n!=".."} then {lappend ll $n}}
   return $ll
   }

proc paint-directory {} {
	global directory
	set z [catch {eg "(directory :path '$directory' ?files)"} m]
	if {$z!=0} then {
		display-eg-error-report self $m "Attempting to read directory" $directory
		error $m
	}
	set dirlist [lsort [strip-dots [dirnames $m]]]
	xv "(LIST :strings ([quote-list $dirlist]))"
}
                 
proc repaint {} {
	global directory file cratelist crateindex
	xv "(DIRECTORY :value '$directory') (FILE :value '$file')"
	set host [lindex $cratelist $crateindex]
	if {[catch {eg "(register :name '/$host/config' ?value)"} config]} then {
		display-eg-error-report self $config "Attempting to read register" /$host/config
		error $config
	}
	xv "(CONFIG :value '$config')"
}

proc click-directory dir {
   global directory file
   set directory $dir
   paint-directory
   set file ""
   repaint
   }

proc click-file name {
	global directory file 
	set file $name
	repaint          
	if {$name!=""&&[string match d* [first [exec ls -ld $directory/$name]]]} then {
      click-directory $directory/$name
	}
}

proc click-list {c file} {
   case $c in {
      :list-select {click-file $file}
      :list-deselect {click-file ""}
      }
   }

proc click-repaint {} {
	paint-directory
	repaint
}

proc click-reconfigure {} {
	global reconformat reconvisible reconframe
	clear-footer
	if {$reconvisible} then {xv "($reconframe :show T)"} else {xv $reconformat}
	set reconvisible 1
	click-repaint
}   

proc click-nam-display {} {
	global namformat namvisible namframe
	clear-footer
	if {$namvisible} then {xv "($namframe :show T)"} else {xv $namformat}
	set namvisible 1
	nam-redisplay
}   

proc do-edit {editor} {
   global directory file
   clear-footer
   set z [catch {
      if {![file exists $directory/$file]} then \
         {error "Edit failed: file does not exist"}
      if {![file isfile $directory/$file]} then \
         {error "Edit failed: invalid file name"}
      exec $editor $directory/$file &
      } result]
   set-footer $result
   }

proc click-edit {m args} {
   if {$m=="Text Editor"} then {do-edit textedit}
   if {$m=="Emacs Editor"} then {do-edit emacs}
   }

proc click-load m {
   if {$m=="File"} then {load-file}
   if {$m=="Default"} then {init-config}
}

proc load-file {} {
	global directory file cratelist crateindex
	set host [lindex $cratelist $crateindex]
	set fullname $directory/$file

	clear-footer
	catch {
		if {![file exists $fullname]} then \
			{error "Load failed: file does not exist"}
		if {![file isfile $fullname]} then \
			{error "Load failed: invalid file name"}
		if {[catch {eg "(register :name '/$host/config'
		                          :value '$directory/$file')"} m]} then {
			display-eg-error-report self $m "Attempting to write value $directory/$file" "to register /$host/config"
			error $m
		}
		click-redisplay
		set result "$host reconfigured with $fullname [exec date]"
	} result
	set-footer $result
}

proc init-config {} {
	global cratelist crateindex
	set host [lindex $cratelist $crateindex]

	clear-footer
	if {[catch {eg "(register :name '/$host/config' !initialise)"} m]} then {
		display-eg-error-report self $m "Attempting to initialise register" /$host/config
		error $m
	}
	click-redisplay
	set-footer "$host reconfigured [exec date]"
}

proc click arg {
	global debug
	if {$debug} then {puts stderr "click with argument \{$arg\}"}
	set f [lindex $arg 0]
	set c [lindex $arg 1]
	set w [lindex $arg 2]
	set v [lindex $arg 3]
	if {$f=="ER"} then {remove-eg-error-report self; return}
	if {$c==":quit"} then {return [click-quit $f]}
	case $w in {
		HOST {click-host $v}
		NAM {click-nam $v}
		HELP {click-help}
		RECON-HELP {click-recon-help}
		REDISPLAY {click-redisplay}
		NAM-DISPLAY {click-nam-display}
		RECONFIGURE {click-reconfigure}
		DIRECTORY {click-directory $v}
		FILE {click-file $v}
		LIST {click-list $c $v}
		REPAINT {click-repaint}
		EDIT-MENU {click-edit $v}
		LOAD-MENU {click-load $v}
	}
}

proc set-footer f {
   global frame
   xv "($frame :left-footer '[quote $f]')"
   }

proc clear-footer {} {
   global frame
   xv "($frame :left-footer ' ')"
   }

proc self op {
   global frame title
   case $op in {
      frame-name {return $frame}
      frame-title {return $title}
      }
   }


proc start args {
	global crateicon crateformat
	xv $crateicon
	xv $crateformat
	click-redisplay
}

proc finish args {
	global frame
	click-quit $frame
}

rp crate


