

#   demon.defn.tcl     Demon VXI card


proc {AddDemonModule}  {module slot}  {
   global registerbase cardtype nsockets
   global file

   set registerbase $cardtype#$module
   set file 0

   delete-vxi-registers $registerbase.*

   DemonVXIRegisters $slot
   DemonModuleRegisters $slot

   for {set socket 1} {$socket <= $nsockets} {incr socket} {

        set registerbase $cardtype[expr $module * $nsockets + $socket - 1]

        delete-vxi-registers $registerbase.*

#    first a register to record module each channel is in
        demon_register  ModuleName    generic "-n$cardtype#$module -tstring -pro"

        DemonVXIRegisters $slot
        DemonModuleRegisters $slot

        DemonDetectorRegisters $slot [expr $socket - 1]
   }
}


proc {BuildDemonModule}  {}  {
   global registerbase cardtype nsockets
   global file

   set registerbase ""

   set f "demon.defn.c"

   set z [catch {open $f w} file]
   if {$z != 0} then {return $file}

   puts $file "LOCAL REG moduleRegister \[\] = {"

   DemonVXIRegisters %d
   DemonModuleRegisters %d

   puts $file "{NULL, NULL, NULL} };"

   puts $file "LOCAL REG detectorRegister \[\] = {"

   DemonDetectorRegisters %d %d

   puts $file "{NULL, NULL, NULL} };"
   
   close $file
   return 0
}

proc demon_register {registername class attributes} {
   global registerbase
   global file

   if {$file == 0} {
       define-vxi-register $registerbase $class $registername "$attributes"
   } else {
       if {$registerbase == ""} then {
           puts $file "\{\"$registername\",   \"$class\",  \"$attributes\"\},"
       } else {
           puts $file "\{\"$registerbase.$registername\",   \"$class\",  \"$attributes\"\},"
       }
   }
}

proc DemonVXIRegisters {slot} {
   demon_register  VXI.ManID      xSht   "-s$slot -o0  -pro -w16 -fx -b0  -l12"
   demon_register  VXI.AddrSpace  xSht   "-s$slot -o0  -pro -w16 -fd -b12 -l2"
   demon_register  VXI.DevClass   xSht   "-s$slot -o0  -pro -w16 -fd -b14 -l2"
   demon_register  VXI.ModelCode  xSht   "-s$slot -o2  -pro -w16 -fx -b0  -l12"
   demon_register  VXI.ReqMem     xSht   "-s$slot -o2  -pro -w16 -fd -b12 -l4"
   demon_register  VXI.Reset      xSht   "-s$slot -o4  -prw -w16 -fd -b0  -l1"
   demon_register  VXI.Passed     xSht   "-s$slot -o4  -pro -w16 -fd -b2  -l1"
   demon_register  VXI.Ready      xSht   "-s$slot -o4  -pro -w16 -fd -b3  -l1"
   demon_register  VXI.ModID      xSht   "-s$slot -o4  -pro -w16 -fd -b14 -l1"
   demon_register  VXI.A24A32     xSht   "-s$slot -o4  -pro -w16 -fd -b15 -l1"
   demon_register  VXI.Offset     xSht   "-s$slot -o6  -pro -w16 -fx"
   demon_register  VXI.SerialNum  xSht   "-s$slot -o8  -pro -w16 -fx"
   demon_register  VXI.ModLevel   xSht   "-s$slot -o10 -pro -w16 -fx"
}

proc DemonModuleRegisters {slot} {

    demon_register   FTMode            xDig "-s$slot -c0 -o0x98 -w16 -prw -fd -b4 -l1 -i0"
    demon_register   ValMode           xDig "-s$slot -c0 -o0x9a -w16 -prw -fd -b4 -l1 -i0"
    
    demon_register   Sumbus_1.Connect       xDig "-s$slot -c0 -o0x9c -w16 -prw -fd -b4 -l1 -i0"
    demon_register   Sumbus_1.Connect1      xDig "-s$slot -c0 -o0x9e -w16 -prw -fd -b4 -l1 -i0"
    demon_register   Sumbus_2.Connect1      xDig "-s$slot -c0 -o0xa0 -w16 -prw -fd -b4 -l1 -i0"
    demon_register   Sumbus_2.Connect2      xDig "-s$slot -c0 -o0xa2 -w16 -prw -fd -b4 -l1 -i0"
    
    demon_register   SSEnable          xDig "-s$slot -c0 -o0xa4 -w16 -prw -fd -b4 -l1 -i0"

    demon_register   Scalers.Load      xDig "-s$slot -c0 -o0x2c -w16 -prw"
    demon_register   Scalers.Clear     xDig "-s$slot -c0 -o0x28 -w16 -prw"

    demon_register   FIFO.TestRegister xDig "-s$slot -c0 -o0x3c -w32 -prw -fx"

    demon_register   Status            xDig "-s$slot -c0 -o0x38 -w16 -prw -fx"
    demon_register   FIFO.NotEmpty     xDig "-s$slot -c0 -o0x38 -w16 -pro -fd -b15 -l1"
    demon_register   LastCard          xDig "-s$slot -c0 -o0x38 -w16 -prw -fd -b0 -l1"
    demon_register   Timeout256        xDig "-s$slot -c0 -o0x38 -w16 -pro -fd -b3 -l4"
    demon_register   TimeoutW3         xDig "-s$slot -c0 -o0x38 -w16 -pro -fd -b8 -l4"

#    demon_register   FT.Width          xDAC "-s$slot -o0x40e -w16 -pwo -qn -us  -d0 -r0:0s,0xff:1275ns   -i250ns"
#    demon_register   FT.Delay          xDAC "-s$slot -o0x30e -w16 -pwo -qn -us  -d0 -r0:0s,0xff:1275ns   -i50ns"
#    demon_register   ValSample         xDAC "-s$slot -o0x50e -w16 -pwo -qn -us  -d0 -r0:0s,0xff:4080ns   -i800ns"
#    demon_register   FT.W3             xDAC "-s$slot -o0x60e -w16 -pwo -qn -us  -d0 -r0:0s,0xff:20400ns  -i20.0us"
#    demon_register   SYREP_QDC_Thresh  xDAC "-s$slot -o0x10e -w16 -pwo -qn -us  -d0 -r0:0s,0xff:20400ns  -i20.0us"
#    demon_register   E&S_QDC_Thresh    xDAC "-s$slot -o0x20e -w16 -pwo -qn -us  -d0 -r0:0s,0xff:20400ns  -i20.0us"

    demon_register   FT.Width          xDig "-s$slot -c0 -o0x40e -w16 -pwo -fd -l8"
    demon_register   FT.Delay          xDig "-s$slot -c0 -o0x30e -w16 -pwo -fd -l8"
    demon_register   ValSample         xDig "-s$slot -c0 -o0x50e -w16 -pwo -fd -l8"
    demon_register   FT.W3             xDig "-s$slot -c0 -o0x60e -w16 -pwo -fd -l8"
    demon_register   SYREP_QDC_Thresh  xDig "-s$slot -c0 -o0x10e -w16 -pwo -fd -l8"
    demon_register   E&S_QDC_Thresh    xDig "-s$slot -c0 -o0x20e -w16 -pwo- fd -l8"

    demon_register   Insp.A1.Channel           xMux "-s$slot -c0 -o0x80 -w16 -prw -b5 -l3 -dDemon -ma1"
    demon_register   Insp.A1.Signal            xDig "-s$slot -c0 -o0x80 -w16 -prw -fd -b0 -l3 -i0"

    demon_register   Insp.A2.Channel           xMux "-s$slot -c0 -o0x82 -w16 -prw -b5 -l3 -dDemon -ma2"
    demon_register   Insp.A2.Signal            xDig "-s$slot -c0 -o0x82 -w16 -prw -fd -b0 -l3 -i0"

    demon_register   Insp.D1.Channel           xMux "-s$slot -c0 -o0x84 -w16 -prw -b5 -l3 -dDemon -md1"
    demon_register   Insp.D1.Signal            xDig "-s$slot -c0 -o0x84 -w16 -prw -fd -b0 -l3 -i0"

    demon_register   Insp.D2.Channel           xMux "-s$slot -c0 -o0x86 -w16 -prw -b5 -l3 -dDemon -md2"
    demon_register   Insp.D2.Signal            xDig "-s$slot -c0 -o0x86 -w16 -prw -fd -b0 -l3 -i0"

    demon_register   Insp.V.Channel            xMux "-s$slot -c0 -o0x88 -w16 -prw -b5 -l3 -dDemon -mv"
    demon_register   Insp.V.Signal             xDig "-s$slot -c0 -o0x88 -w16 -prw -fd -b0 -l4 -i0"
}

proc DemonDetectorRegisters {slot c} {
    global registerbase file

#    demon_register  CFD.Delay         xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x02 -w16 -pwo -qn -us -d0 -r0:0s,0xff:255ns -i5ns"
#    demon_register  CFD.Thresh        xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x00 -w16 -pwo -qm -uV -d0 -r0:0s,0xff:500mV -i30mV"
#    demon_register  CFD.Width         xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x04 -w16 -pwo -qn -us -d0 -r0:0s,0xff:255ns -i200ns"
  
#    demon_register  Gate.Delay        xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x08 -w16 -pwo -qm -uV -d0 -r0:0s,0xff:500mV -i30mV"
#    demon_register  Gate.Width        xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x06 -w16 -pwo -qn -us -d0 -r0:0s,0xff:255ns -i200ns"

#    demon_register  FTSample          xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x0a -w16 -pwo -qn -us -d0 -r0:0s,0xff:1275ns -i190ns"
#    demon_register  ChanTrigW3        xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x0c -w16 -pwo -qn -us -d0 -r0:0s,0xff:5100ns -i3300ns"
    
#    demon_register  SYREP.Thresh      xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x40 -w32 -pwo -qm -uV -d0 -r0:0s,0xff:500mV -i30mV"
#    demon_register  Entire.Thresh     xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x44 -w32 -pwo -qm -uV -d0 -r0:0s,0xff:500mV -i30mV"
#    demon_register  Slow.Thresh       xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x48 -w32 -pwo -qm -uV -d0 -r0:0s,0xff:500mV -i30mV"
#    demon_register  Time.Thresh       xDAC "-s$slot -c$c -a0x0100 -z0x100 -o0x4c -w32 -pwo -qm -uV -d0 -r0:0s,0xff:500mV -i30mV"

    demon_register  CFD.Delay         xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x02 -w16 -pwo -fd -l8"
    demon_register  CFD.Thresh        xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x00 -w16 -pwo -fd -l8"
    demon_register  CFD.Width         xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x04 -w16 -pwo -fd -l8"
    
    demon_register  Gate.Delay        xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x08 -w16 -pwo -fd -l8"
    demon_register  Gate.Width        xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x06 -w16 -pwo -fd -l8"

    demon_register  FTSample          xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x0a -w16 -pwo -fd -l8"
    demon_register  ChanTrigW3        xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x0c -w16 -pwo -fd -l8"
    
    demon_register  SYREP.Thresh      xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x40 -w32 -prw -fd -l16 -b16"
    demon_register  Entire.Thresh     xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x44 -w32 -prw -fd -l16 -b16"
    demon_register  Slow.Thresh       xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x48 -w32 -prw -fd -l16 -b16"
    demon_register  Time.Thresh       xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x4c -w32 -prw -fd -l16 -b16"

    if {$file == 0} then {
       demon_register  SYREP.Addr        xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x50 -pwo -w32 -l16 -b16 -i$registerbase.SYREP"
       demon_register  Entire.Addr       xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x54 -pwo -w32 -l16 -b16 -i$registerbase.Entire"
       demon_register  Slow.Addr         xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x58 -pwo -w32 -l16 -b16 -i$registerbase.Slow"
       demon_register  Time.Addr         xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x5c -pwo -w32 -l16 -b16 -i$registerbase.Time"
    } else {
       demon_register  SYREP.Addr        xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x50 -pwo -w32 -l16 -b16"
       demon_register  Entire.Addr       xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x54 -pwo -w32 -l16 -b16"
       demon_register  Slow.Addr         xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x58 -pwo -w32 -l16 -b16"
       demon_register  Time.Addr         xAdr "-s$slot -c$c -a0x0100 -z0x100 -o0x5c -pwo -w32 -l16 -b16"
    }

    demon_register  SYREP.data        xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x60 -w32 -pro -fx"
    demon_register  Entire.data       xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x64 -w32 -pro -fx"
    demon_register  Slow.data         xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x68 -w32 -pro -fx"
    demon_register  Time.data         xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x6c -w32 -pro -fx"

    demon_register  SYREP.SSEnable    xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x70 -w32 -prw -fd -b16 -l1 -i1"
    demon_register  Entire.SSEnable   xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x70 -w32 -prw -fd -b17 -l1 -i1"
    demon_register  Slow.SSEnable     xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x70 -w32 -prw -fd -b18 -l1 -i1"
    demon_register  Time.SSEnable     xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x70 -w32 -prw -fd -b19 -l1 -i1"

    demon_register  SYREP.ROEnable    xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x74 -w32 -prw -fd -b16 -l1 -i1"
    demon_register  Entire.ROEnable   xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x74 -w32 -prw -fd -b17 -l1 -i1"
    demon_register  Slow.ROEnable     xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x74 -w32 -prw -fd -b18 -l1 -i1"
    demon_register  Time.ROEnable     xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x74 -w32 -prw -fd -b19 -l1 -i1"

    demon_register  SlidingScale      xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x78 -w32 -pro -fd -b16 -l16"
    demon_register  TestRegister      xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x7c -w32 -pwo -fd -b16 -l16"

    demon_register  Sumbus_2.Enable   xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x94 -w16 -prw -fd -b2 -l1"
    demon_register  LEMO.Enable       xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x96 -w16 -prw -fd -b3 -l1"
    demon_register  CFD.Enable        xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x90 -w16 -prw -fd -b0 -l1"
    demon_register  Test.Enable       xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x92 -w16 -prw -fd -b1 -l1"

    demon_register  PromptScaler      xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x20 -w32 -pro -fd"
    demon_register  ADCScaler         xDig "-s$slot -c$c -a0x0100 -z0x100 -o0x24 -w32 -pro -fd"


}


proc Demon_DAQ-reset   {args}   {
   set module [first $args]
#    no action
}


proc Demon_DAQ-halt   {args}   {
   set module [first $args]
#    no action
}


proc Demon_DAQ-go   {args}   {
   set module [first $args]
#    no action
}
