/* ****************************************************************/ 
/*	ADSP-21060            tgirmain.asm pour DSP TGIRBGA		*/
/*	LCA TGIR envoie un Start avec l'IRQ0				*/
/*	Le DSP de TGIR attend 4s 						*/
/*	Il met le FLAG0 a 1 et transfert par DMA un bloc de datas	*/
/*	A la fin du transfert, il met le FLAG0 a 0			*/																				
/******************************************************************/

#include "def21060.h"
#define nbdata 16

.EXTERN zeroint;
.EXTERN reset;		/* reset.asm */
.EXTERN transdma; 


.GLOBAL demar;		/* boucle de demarrage */

/* variables */
.GLOBAL choix;
.GLOBAL nbtransf;

.GLOBAL ver0;
.GLOBAL ver1;
.GLOBAL ver2;
.GLOBAL ver3;
.GLOBAL ver4;
.GLOBAL ver5;
.GLOBAL ver6;
.GLOBAL ver7;
.GLOBAL ver8;
.GLOBAL ver9;
.GLOBAL verec7;

/* datas vme */
.GLOBAL choix_vme;

/******************************************************************************/
.segment /pm    rst_svc;	/* 0x20004 a 0x20007 */
/******************************************************************************/

	idle;
	jump main;

.endseg;

/******************************************************************************/
.segment /pm     irq0_svc;	/* 0x20 a 0x23 */
/******************************************************************************/

	rti(db);		/* segment Interruption IRQ1 */
	bit clr imask IRQ0I;
	bit set astat FLG1; /* stop dma */

.endseg;

/******************************************************************************/
.segment /dm variable;		/* 0x26000 a 0x2601F */
/******************************************************************************/

.var choix;             	/* choix de la routine a effectuer */
.var nbtransf;			/* nb d'interrupt DMA7=nb d'events PARIL vers dsp */

.var ver0;
.var ver1;
.var ver2;
.var ver3;
.var ver4;
.var ver5;
.var ver6;
.var ver7;
.var ver8;
.var ver9;
.var verec7;			/* compteur dma apres transmission des datas ds memext */

.endseg;


/******************************************************************************/
.SEGMENT/DM     dm_vme;			/* 0x2ffd0 a 0x2ffff*/  
/******************************************************************************/  
	.var choix_vme; 		/* choix du programme */ 
	.VAR traitfif;   		/* traitement dsptofifo */

.ENDSEG;  

/******************************************************************************/
.segment /pm pm_proge;	/* 0x20100 a 0x203FF */
/******************************************************************************/

main:
	   
	r15=0; 

	
	/*--------------------------------------------------------------*/
	/* 		initialisation du wait register 		*/
	/*--------------------------------------------------------------*/
test1 : r0=0x21a084A1; dm(WAIT)=r0;     	/* pas de waitstate pour les bank 0,2,3 */
	r0=dm(WAIT); 				/* 1 waitstate pour le bank 1 */
	r1=0x21a084A1; r1=r1 XOR r0; if ne jump test1;
	nop; nop; nop; nop;			/* internal ack only */


	/*--------------------------------------------------------------*/
	/* 		initialisation du SYSCON	 		*/
	/*--------------------------------------------------------------*/
test2 : r0=0x6400; dm(SYSCON)=r0;       /* taille du Bank1 de la mem ext 256kmots */
	r0=dm(SYSCON);    		/* host packing mode 32 to 48 bit words */
	r1=0x6400; r1=r1 XOR r0; if ne jump test2;
	nop; nop; nop; nop;

r14=pass r15;
call reset;

      bit set mode1 IRPTEN;  /* autorise toutes les interruptions 3-21 */
	bit clr imask IRQ0I;	/* disable l'interruption IRQ0 pour DAQ*/
	bit set mode2 IRQ0E;	/* IRQ0 edge sensitive */
	bit set mode2 FLG0O;	/* flag0 en output transdma*/
	bit set mode2 FLG2O;	/* flag0 en output ANAL2DSP*/
	bit set mode2 FLG3O;	/* flag1 en output DSP2FIFO*/
	bit set mode2 FLG1O;	/* flag2 en output Timing*/

	bit clr astat FLG0;
	bit clr astat FLG2;
	bit clr astat FLG3;
	bit clr astat FLG1;

	dm(ver0)=r15;
	dm(ver1)=r15;
	dm(ver2)=r15;
	dm(ver3)=r15;
	

demar : 	bit clr astat FLG1;
 	bit set imask IRQ0I;	/* attend start de LCA TGIR*/
wait : idle;
	nop;nop;
	call transdma(db);
	r0=0x1; dm(choix)=r0;



.endseg;
/******************************************************************************/