#    hist task code overlay for detector type "icare"


set lowchannel  0
set highchannel 247
set maxchannel  247

set icarenames   {Adc0 Adc1 Adc2 Adc3}

set icare 0


proc make-overlaypanel {} {
   global icarenames

    :layout V; :row-gap 10; :col-gap 20

      :message DET-M1   :label "Icare overlay applied"

      :number DET-LOW  :label "Low channel:"  :w 5 :valuex 15c
      :number DET-HIGH :label "High channel:" :w 5 :valuex 15c

      :choice DET-ICARE   :label "Items"   :valuex 15c  :exclusive F :strings $icarenames  :value 0
}



#    this proc handles events from widgets created in the proc make-overlaypanel
#    The widgets DET-LOW; DET-HIGH and DET-QUAL are handled in the main click procedure
#    and are not required here

proc click-overlay {w v} {

   switch -glob $w {
      DET-ICARE     {click-adc $v icare}
      default      {puts stdout $arg}
   }
}

proc repaint_overlay {} {
   global spectrumlist
   global icare

   if {[llength $spectrumlist] > 0} then {
       :modify DET-ICARE   :value 0
   } else {
       :modify DET-ICARE   :value $icare
   }
}


proc get-spectrum-list {} {
        global spectrumlist
        global icarenames icare
        global lowchannel highchannel

        if {$spectrumlist != {}} then {return $spectrumlist};  # return names selected from spectrum list

        set list {}
# append  spectrum names
        for {set i $lowchannel} {$i<=$highchannel} {incr i} {
            foreach adc [list-take $icarenames  [bits-in $icare]]  {lappend list Icare$i.$adc}
        }
        return $list
}

proc range-of n {return 2048}
