

set debug 0
set EGreport 0
set started 0

set frame VXISTATUS
set frametitle "VXI System Status"
set icontitle  "VXISTATUS"

if {[info exists env(VXIServer)] == 0} then {set VXIServer VXI}  \
   else {set VXIServer $env(VXIServer)}

set CurrentVXIServer VXI
set TrigServer vxi1
set TrigModule Trig
set Trigpres 0

set VXICrateList {}

foreach c {1 2 3 4 5 6 7 8 9 10} {
  lappend VXICrateList "vxi$c"
  set VXIModuleList(vxi$c) {}
  set VXIGO(vxi$c) 0
  set RMVXIGO(vxi$c) 0
  set RMINHACT(vxi$c) 0
  set RMINHREQ(vxi$c) 0
  set RESET(vxi$c) 0
  set RESTORED(vxi$c) 0
  set AI1(vxi$c) disconnected
  set AI2(vxi$c) disconnected
  set DI1(vxi$c) disconnected
  set DI2(vxi$c) disconnected
  set VI(vxi$c) disconnected
}
set TRIGVXIGO 0

set NeedNewFrame 1
set NumCrates -1

proc update-lists {} {
   global VXICrateList VXIModuleList Trigpres TrigServer TrigModule
   global NumCrates NeedNewFrame

    set Trigpres [inform vxicontrol inquire Trigpres]
    set TrigServer [inform vxicontrol inquire TrigServer]
    set TrigModule [inform vxicontrol inquire TrigModule]
    set VXICrateList [inform vxicontrol inquire VXICrateList]
    foreach crate $VXICrateList {
       set VXIModuleList($crate) [inform vxicontrol set VXIModuleList($crate)]
    }
    if {[llength $VXICrateList] == $NumCrates} then {set NeedNewFrame 0}  \
        else {set NeedNewFrame 1; set NumCrates [llength $VXICrateList]}
}

proc update-status {} {
  global VXICrateList VXIModuleList Trigpres TrigModule
  global VXIGO RESET RESTORED RMVXIGO RMINHREQ RMINHACT TRIGVXIGO AI1 AI2 DI1 DI2 VI

   foreach c $VXICrateList {
      set server $c
#    Crate Reset flag
      set RESET($c) [EG "register :name '/$server/NetVar_HasBeenReset' ?value"]
#    Crate Restore flag
      set RESTORED($c) [EG "register :name '/$server/NetVar_HasBeenRestored' ?value"]
#    Trigger state
      if {$Trigpres} then {
        set TRIGVXIGO [read-vxi-reg $TrigModule.VXI.Go]
      } else {
        set TRIGVXIGO 0
      }
#    VXI GO crate backplane line
      set RM [lindex $VXIModuleList($c) [lsearch $VXIModuleList($c) RM*]]
      if {"$RM" == ""} then {
          set RM [lindex $VXIModuleList($c) [lsearch $VXIModuleList($c) SlotOne*]]
      }
      if {"$RM" == ""} then {set state 0} else {set state [EG "register :name '/$server/$RM.TTLTRG' ?value"]}
      set VXIGO($c)  [expr $state >> 4 & 1]
#    RM VXI GO register
      if {"$RM" == ""} then {set state 0} else {set state [EG "register :name '/$server/$RM.VXI.Go' ?value"]}
      set RMVXIGO($c) $state
#    RM Inhibit Action register
      if {"$RM" == ""} then {set state 0} else {set state [EG "register :name '/$server/$RM.TTLTRG' ?value"]}
      set RMINHACT($c) [expr $state & 0x80]
#    RM Inhibit Request register
      if {"$RM" == ""} then {set state 0} else {set state [EG "register :name '/$server/$RM.ECLTRG' ?value"]}
      set RMINHREQ($c) [expr $state & 0x04]
#    AI 1 inspection line
      set AI1($c) [EG "register :name '/$server/NetVar_Inspection_AI1' ?value"]
#    AI 2 inspection line
      set AI2($c) [EG "register :name '/$server/NetVar_Inspection_AI2' ?value"]
#    DI 1 inspection line
      set DI1($c) [EG "register :name '/$server/NetVar_Inspection_DI1' ?value"]
#    DI 2 inspection line
      set DI2($c) [EG "register :name '/$server/NetVar_Inspection_DI2' ?value"]
#    DI 2 inspection line
      set DI2($c) [EG "register :name '/$server/NetVar_Inspection_DI2' ?value"]
#    VI inspection line
      set VI($c) [EG "register :name '/$server/NetVar_Inspection_VI' ?value"]
  }
}

proc read-vxi-reg {register} {
   global CurrentVXIServer TrigServer TrigModule VXIregister EGallow
   set EGallow 0x10002
   if {[first [split $register .]] == $TrigModule} then {
      set VXIregister /$TrigServer/$register
   } else {
      set VXIregister /$CurrentVXIServer/$register
   }
   EG "register :name '$VXIregister' ?value"
}

proc show-state {} {
   global VXICrateList VXIModuleList Trigpres CurrentVXIServer
   global EGreport
   global VXIGO RESET RESTORED RMVXIGO RMINHREQ RMINHACT TRIGVXIGO AI1 AI2 DI1 DI2 VI

    set EGreport_save $EGreport
    if {$EGreport == 0} then {set EGreport -1}

    update-lists
    update-status

    set EGreport $EGreport_save

#    create a window for the status information
    set frame [self frame-name].statusinfo

    :frame $frame :label  "VXI System status at [date]" :transient T
    :galley G :deaf T :strings ""
    :show T

    if {$Trigpres} then {
      :modify G :strings "System contains a Master Trigger module "
      if {$TRIGVXIGO == 0} then {set s NOT} else {set s ""}
      :modify G :strings "and its VXI GO register is $s set"
    } else {
      :modify G :strings "System does NOT contain a Master Trigger module"
    }

   foreach crate $VXICrateList {
      update idletasks
#  obtain status of this VXI crate
#      set server [VXIcrate2server $crate]
      set server $crate
      set CurrentVXIServer $server
      :modify G :strings "\n\nVXI crate $crate has server $server\n"
      set s [EG "register :name '/$server/NetVar_MyHostName' ?value"]
      :modify G :strings "Server has host name $s\n"
      set s [EG "register :name '/$server/NetVar_MyVXICrate' ?value"]
      :modify G :strings "Server has name $s\n"
      set s [EG "register :name '/$server/NetVar_ServerType' ?value"]
      :modify G :strings "Server has type $s\n"
      if {$RESET($crate) == 0} then {set s NOT} else {set s ""}
      :modify G :strings "Crate has $s been software reset\n"
      if {$RESTORED($crate) == 0} then {set s NOT} else {set s ""}
      :modify G :strings "A parameter restore has $s been performed\n"
      if {$VXIGO($crate) == 0} then {set s NOT} else {set s ""}
      :modify G :strings "VXI GO backplane line is $s set\n"
      if {$RMVXIGO($crate) == 0} then {set s NOT} else {set s ""}
      :modify G :strings "RM VXI GO register is $s set\n"
      if {$RMINHREQ($crate) == 0} then {set s NOT} else {set s ""}
      :modify G :strings "RM Inhibit Request register is $s set\n"
      if {$RMINHACT($crate) == 0} then {set s NOT} else {set s ""}
      :modify G :strings "RM Action Request register is $s set\n"
      :modify G :strings "Inspection line analogue 1 is $AI1($crate)\n"
      :modify G :strings "Inspection line analogue 2 is $AI2($crate)\n"
      :modify G :strings "Inspection line digital 1  is $DI1($crate)\n"
      :modify G :strings "Inspection line digital 2  is $DI2($crate)\n"
      :modify G :strings "Inspection line voltage    is $VI($crate)\n"
      :modify G :strings "Probing VXI crate for modules present\n"
      set s [EG "register :pattern '/$server/*.VXI.Passed' ?names-and-values"]
      set modules_0 {}
      set modules_1 {}
      foreach item $s {
         set module [first [split [first $item] .]]
         if {![string match *#* $module]} then {
            if {[second $item] == 1} then {
              if {[lsearch $modules_1 $module] < 0} then {lappend modules_1 $module}
            } else {
              if {[lsearch $modules_0 $module] < 0} then {lappend modules_0 $module}
            }
         }
      }
      if {[llength $modules_1] > 0} then {:modify G :strings "modules present $modules_1\n"}
      if {[llength $modules_0] > 0} then {:modify G :strings "modules missing $modules_0\n"}
   }
}

proc make-frame {} {
   global env started NeedNewFrame
   global VXICrateList Trigpres TRIGVXIGO VXIGO RMVXIGO RMINHREQ RMINHACT RESET RESTORED 

 if {$NeedNewFrame == 1} then {

  :frame [self frame-name] :label "[self frame-title]"     \
      :show-footer T  :resize F \
      :icon-image "@$env(ICONHOME)/vxi_crate" \
      :icon-name "[self icon-title]"

   :panel CLICK :layout T :padx 10
      :layout H; :row-gap 5; :col-gap 5
      :button REDISPLAY 
      :button SHOWVXI    :label "Show VXI state" :command show-state
 }

  if {$started != 0} then {

 if {$NeedNewFrame == 1} then {
   :panel STATUS :layout T :padx 10 :pady 10
      :layout H; :row-gap 10; :col-gap 10
 }

    if {$Trigpres} then {
      set m "System contains a Master Trigger module "
      if {$TRIGVXIGO == 0} then {set s NOT} else {set s ""}
      append m "and its VXI GO register is $s set"
    } else {
      set m "System does NOT contain a Master Trigger module"
    }
 if {$NeedNewFrame == 1} then {
    :message M1 :label "$m" :bold T
 } else {
    :modify M1 :label "$m"
 }

 if {$NeedNewFrame == 1} then {
    :next-row T
     :message M2 :label "State of VXI software RESET flag" :bold T
     :next-row T
 }
     foreach c $VXICrateList {
 if {$NeedNewFrame == 1} then {
        :checkbox RESET$c :label $c :value $RESET($c) :deaf T
 } else {
        :modify RESET$c :value $RESET($c)
 }
     }

 if {$NeedNewFrame == 1} then {
    :next-row T
     :message M3 :label "State of VXI parameter RESTORE flag" :bold T
     :next-row T
 }
     foreach c $VXICrateList {
 if {$NeedNewFrame == 1} then {
        :checkbox RESTORED$c :label $c :value $RESTORED($c) :deaf T
 } else {
        :modify RESTORED$c :value $RESTORED($c)
 }
     }

 if {$NeedNewFrame == 1} then {
    :next-row T
     :message M4 :label "State of VXI GO backplane line" :bold T
     :next-row T
 }
     foreach c $VXICrateList {
 if {$NeedNewFrame == 1} then {
        :checkbox VXIGO$c :label $c :value $VXIGO($c) :deaf T
 } else {
        :modify VXIGO$c :value $VXIGO($c)
 }
     }

 if {$NeedNewFrame == 1} then {
    :next-row T
     :message M5 :label "State of RM VXI GO register" :bold T
     :next-row T
 }
     foreach c $VXICrateList {
 if {$NeedNewFrame == 1} then {
        :checkbox RMVXIGO$c :label $c :value $RMVXIGO($c) :deaf T
 } else {
        :modify RMVXIGO$c :value $RMVXIGO($c)
 }
     }

 if {$NeedNewFrame == 1} then {
    :next-row T
     :message M7 :label "State of RM Inhibit Request register" :bold T
     :next-row T
 }
     foreach c $VXICrateList {
 if {$NeedNewFrame == 1} then {
        :checkbox RMINHREQ$c :label $c :value $RMINHREQ($c) :deaf T
 } else {
        :modify RMINHREQ$c :value $RMINHREQ($c)
 }
     }

 if {$NeedNewFrame == 1} then {
    :next-row T
     :message M8 :label "State of RM Inhibit Action register" :bold T
     :next-row T
 }
     foreach c $VXICrateList {
 if {$NeedNewFrame == 1} then {
        :checkbox RMINHACT$c :label $c :value $RMINHACT($c) :deaf T
 } else {
        :modify RMINHACT$c :value $RMINHACT($c)
 }
     }

 if {$NeedNewFrame == 1} then {
     do-inspection
 } else {
     update-inspection
 }
   set-footer "last updated [date]"
  }
   :show T
}

proc do-inspection {} {
  global VXICrateList
  global AI1 AI2 DI1 DI2 VI
    :next-row T
    :row-gap 0
    :message M6 :label "Inspection lines" :bold T
     foreach c $VXICrateList {
        :row-gap 0
        :next-row T
        :message MC$c    :label $c  :bold T
        :message MAI1$c  :label "AI1 is $AI1($c)"
        :message MAI2$c  :label "AI2 is $AI2($c)"
        :row-gap -7
        :next-row T
        :hskip 45
        :message MDI1$c  :label "DI1 is $DI1($c)"
        :message MDI2$c  :label "DI2 is $DI2($c)"
     }
}

proc update-inspection {} {
  global VXICrateList
  global AI1 AI2 DI1 DI2 VI
     foreach c $VXICrateList {
        :modify MAI1$c  :label "AI1 is $AI1($c)"
        :modify MAI2$c  :label "AI2 is $AI2($c)"
        :modify MDI1$c  :label "DI1 is $DI1($c)"
        :modify MDI2$c  :label "DI2 is $DI2($c)"
     }
}

proc click-redisplay {} {
   clear-footer
   update-lists
   update-status
   make-frame
}

proc start args {
   global started
   if {$started == 0} then {make-frame}
   set started 1
   open-frame
   click-redisplay
}

proc click-quit args {close-frame} 

proc finish args {destroy-frame}

